# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['RemoteAnsibleRepositoryArgs', 'RemoteAnsibleRepository']

@pulumi.input_type
class RemoteAnsibleRepositoryArgs:
    def __init__(__self__, *,
                 key: pulumi.Input[builtins.str],
                 allow_any_host_auth: Optional[pulumi.Input[builtins.bool]] = None,
                 archive_browsing_enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 assumed_offline_period_secs: Optional[pulumi.Input[builtins.int]] = None,
                 blacked_out: Optional[pulumi.Input[builtins.bool]] = None,
                 block_mismatching_mime_types: Optional[pulumi.Input[builtins.bool]] = None,
                 bypass_head_requests: Optional[pulumi.Input[builtins.bool]] = None,
                 cdn_redirect: Optional[pulumi.Input[builtins.bool]] = None,
                 client_tls_certificate: Optional[pulumi.Input[builtins.str]] = None,
                 content_synchronisation: Optional[pulumi.Input['RemoteAnsibleRepositoryContentSynchronisationArgs']] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 disable_proxy: Optional[pulumi.Input[builtins.bool]] = None,
                 disable_url_normalization: Optional[pulumi.Input[builtins.bool]] = None,
                 download_direct: Optional[pulumi.Input[builtins.bool]] = None,
                 enable_cookie_management: Optional[pulumi.Input[builtins.bool]] = None,
                 excludes_pattern: Optional[pulumi.Input[builtins.str]] = None,
                 hard_fail: Optional[pulumi.Input[builtins.bool]] = None,
                 includes_pattern: Optional[pulumi.Input[builtins.str]] = None,
                 list_remote_folder_items: Optional[pulumi.Input[builtins.bool]] = None,
                 local_address: Optional[pulumi.Input[builtins.str]] = None,
                 metadata_retrieval_timeout_secs: Optional[pulumi.Input[builtins.int]] = None,
                 mismatching_mime_types_override_list: Optional[pulumi.Input[builtins.str]] = None,
                 missed_cache_period_seconds: Optional[pulumi.Input[builtins.int]] = None,
                 notes: Optional[pulumi.Input[builtins.str]] = None,
                 offline: Optional[pulumi.Input[builtins.bool]] = None,
                 password: Optional[pulumi.Input[builtins.str]] = None,
                 priority_resolution: Optional[pulumi.Input[builtins.bool]] = None,
                 project_environments: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 project_key: Optional[pulumi.Input[builtins.str]] = None,
                 property_sets: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 proxy: Optional[pulumi.Input[builtins.str]] = None,
                 query_params: Optional[pulumi.Input[builtins.str]] = None,
                 remote_repo_layout_ref: Optional[pulumi.Input[builtins.str]] = None,
                 repo_layout_ref: Optional[pulumi.Input[builtins.str]] = None,
                 retrieval_cache_period_seconds: Optional[pulumi.Input[builtins.int]] = None,
                 share_configuration: Optional[pulumi.Input[builtins.bool]] = None,
                 socket_timeout_millis: Optional[pulumi.Input[builtins.int]] = None,
                 store_artifacts_locally: Optional[pulumi.Input[builtins.bool]] = None,
                 synchronize_properties: Optional[pulumi.Input[builtins.bool]] = None,
                 unused_artifacts_cleanup_period_hours: Optional[pulumi.Input[builtins.int]] = None,
                 url: Optional[pulumi.Input[builtins.str]] = None,
                 username: Optional[pulumi.Input[builtins.str]] = None,
                 xray_index: Optional[pulumi.Input[builtins.bool]] = None):
        """
        The set of arguments for constructing a RemoteAnsibleRepository resource.
        :param pulumi.Input[builtins.str] key: A mandatory identifier for the repository that must be unique. It cannot begin with a number or
               contain spaces or special characters.
        :param pulumi.Input[builtins.bool] allow_any_host_auth: 'Lenient Host Authentication' in the UI. Allow credentials of this repository to be used on requests redirected to any
               other host.
        :param pulumi.Input[builtins.bool] archive_browsing_enabled: When set, you may view content such as HTML or Javadoc files directly from Artifactory. This may not be safe and
               therefore requires strict content moderation to prevent malicious users from uploading content that may compromise
               security (e.g., cross-site scripting attacks).
        :param pulumi.Input[builtins.int] assumed_offline_period_secs: The number of seconds the repository stays in assumed offline state after a connection error. At the end of this time,
               an online check is attempted in order to reset the offline status. A value of 0 means the repository is never assumed
               offline.
        :param pulumi.Input[builtins.bool] blacked_out: (A.K.A 'Ignore Repository' on the UI) When set, the repository or its local cache do not participate in artifact
               resolution.
        :param pulumi.Input[builtins.bool] block_mismatching_mime_types: If set, artifacts will fail to download if a mismatch is detected between requested and received mimetype, according to
               the list specified in the system properties file under blockedMismatchingMimeTypes. You can override by adding mimetypes
               to the override list 'mismatching_mime_types_override_list'.
        :param pulumi.Input[builtins.bool] bypass_head_requests: Before caching an artifact, Artifactory first sends a HEAD request to the remote resource. In some remote resources,
               HEAD requests are disallowed and therefore rejected, even though downloading the artifact is allowed. When checked,
               Artifactory will bypass the HEAD request and cache the artifact directly using a GET request.
        :param pulumi.Input[builtins.bool] cdn_redirect: When set, download requests to this repository will redirect the client to download the artifact directly from AWS
               CloudFront. Available in Enterprise+ and Edge licenses only. Default value is 'false'
        :param pulumi.Input[builtins.str] client_tls_certificate: Client TLS certificate name.
        :param pulumi.Input[builtins.str] description: Public description.
        :param pulumi.Input[builtins.bool] disable_proxy: When set to `true`, the proxy is disabled, and not returned in the API response body. If there is a default proxy set
               for the Artifactory instance, it will be ignored, too. Introduced since Artifactory 7.41.7.
        :param pulumi.Input[builtins.bool] disable_url_normalization: Whether to disable URL normalization. Default is `false`.
        :param pulumi.Input[builtins.bool] download_direct: When set, download requests to this repository will redirect the client to download the artifact directly from the cloud
               storage provider. Available in Enterprise+ and Edge licenses only. Default value is 'false'.
        :param pulumi.Input[builtins.bool] enable_cookie_management: Enables cookie management if the remote repository uses cookies to manage client state.
        :param pulumi.Input[builtins.str] excludes_pattern: List of artifact patterns to exclude when evaluating artifact requests, in the form of `x/y/**/z/*`.By default no
               artifacts are excluded.
        :param pulumi.Input[builtins.bool] hard_fail: When set, Artifactory will return an error to the client that causes the build to fail if there is a failure to
               communicate with this repository.
        :param pulumi.Input[builtins.str] includes_pattern: List of comma-separated artifact patterns to include when evaluating artifact requests in the form of `x/y/**/z/*`. When
               used, only artifacts matching one of the include patterns are served. By default, all artifacts are included (`**/*`).
        :param pulumi.Input[builtins.bool] list_remote_folder_items: Lists the items of remote folders in simple and list browsing. The remote content is cached according to the value of
               the 'Retrieval Cache Period'. Default value is 'false'. This field exists in the API but not in the UI.
        :param pulumi.Input[builtins.str] local_address: The local address to be used when creating connections. Useful for specifying the interface to use on systems with
               multiple network interfaces.
        :param pulumi.Input[builtins.int] metadata_retrieval_timeout_secs: Metadata Retrieval Cache Timeout (Sec) in the UI.This value refers to the number of seconds to wait for retrieval from
               the remote before serving locally cached artifact or fail the request.
        :param pulumi.Input[builtins.str] mismatching_mime_types_override_list: The set of mime types that should override the block_mismatching_mime_types setting. Eg:
               'application/json,application/xml'. Default value is empty.
        :param pulumi.Input[builtins.int] missed_cache_period_seconds: Missed Retrieval Cache Period (Sec) in the UI. The number of seconds to cache artifact retrieval misses (artifact not
               found). A value of 0 indicates no caching.
        :param pulumi.Input[builtins.str] notes: Internal description.
        :param pulumi.Input[builtins.bool] offline: If set, Artifactory does not try to fetch remote artifacts. Only locally-cached artifacts are retrieved.
        :param pulumi.Input[builtins.bool] priority_resolution: Setting repositories with priority will cause metadata to be merged only from repositories set with this field
        :param pulumi.Input[builtins.str] project_key: Project key for assigning this repository to. Must be 2 - 32 lowercase alphanumeric and hyphen characters. When
               assigning repository to a project, repository key must be prefixed with project key, separated by a dash.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] property_sets: List of property set name
        :param pulumi.Input[builtins.str] proxy: Proxy key from Artifactory Proxies settings. Can't be set if `disable_proxy = true`.
        :param pulumi.Input[builtins.str] query_params: Custom HTTP query parameters that will be automatically included in all remote resource requests. For example:
               `param1=val1&param2=val2&param3=val3`
        :param pulumi.Input[builtins.str] remote_repo_layout_ref: Repository layout key for the remote layout mapping. Repository can be created without this attribute (or set to an
               empty string). Once it's set, it can't be removed by passing an empty string or removing the attribute, that will be
               ignored by the Artifactory API. UI shows an error message, if the user tries to remove the value.
        :param pulumi.Input[builtins.str] repo_layout_ref: Sets the layout that the repository should use for storing and identifying modules. A recommended layout that
               corresponds to the package type defined is suggested, and index packages uploaded and calculate metadata accordingly.
        :param pulumi.Input[builtins.int] retrieval_cache_period_seconds: Metadata Retrieval Cache Period (Sec) in the UI. This value refers to the number of seconds to cache metadata files
               before checking for newer versions on remote server. A value of 0 indicates no caching.
        :param pulumi.Input[builtins.int] socket_timeout_millis: Network timeout (in ms) to use when establishing a connection and for unanswered requests. Timing out on a network
               operation is considered a retrieval failure.
        :param pulumi.Input[builtins.bool] store_artifacts_locally: When set, the repository should store cached artifacts locally. When not set, artifacts are not stored locally, and
               direct repository-to-client streaming is used. This can be useful for multi-server setups over a high-speed LAN, with
               one Artifactory caching certain data on central storage, and streaming it directly to satellite pass-though Artifactory
               servers.
        :param pulumi.Input[builtins.bool] synchronize_properties: When set, remote artifacts are fetched along with their properties.
        :param pulumi.Input[builtins.int] unused_artifacts_cleanup_period_hours: Unused Artifacts Cleanup Period (Hr) in the UI. The number of hours to wait before an artifact is deemed 'unused' and
               eligible for cleanup from the repository. A value of 0 means automatic cleanup of cached artifacts is disabled.
        :param pulumi.Input[builtins.str] url: The remote repo URL.
        :param pulumi.Input[builtins.bool] xray_index: Enable Indexing In Xray. Repository will be indexed with the default retention period. You will be able to change it via
               Xray settings.
        """
        pulumi.set(__self__, "key", key)
        if allow_any_host_auth is not None:
            pulumi.set(__self__, "allow_any_host_auth", allow_any_host_auth)
        if archive_browsing_enabled is not None:
            pulumi.set(__self__, "archive_browsing_enabled", archive_browsing_enabled)
        if assumed_offline_period_secs is not None:
            pulumi.set(__self__, "assumed_offline_period_secs", assumed_offline_period_secs)
        if blacked_out is not None:
            pulumi.set(__self__, "blacked_out", blacked_out)
        if block_mismatching_mime_types is not None:
            pulumi.set(__self__, "block_mismatching_mime_types", block_mismatching_mime_types)
        if bypass_head_requests is not None:
            pulumi.set(__self__, "bypass_head_requests", bypass_head_requests)
        if cdn_redirect is not None:
            pulumi.set(__self__, "cdn_redirect", cdn_redirect)
        if client_tls_certificate is not None:
            pulumi.set(__self__, "client_tls_certificate", client_tls_certificate)
        if content_synchronisation is not None:
            pulumi.set(__self__, "content_synchronisation", content_synchronisation)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if disable_proxy is not None:
            pulumi.set(__self__, "disable_proxy", disable_proxy)
        if disable_url_normalization is not None:
            pulumi.set(__self__, "disable_url_normalization", disable_url_normalization)
        if download_direct is not None:
            pulumi.set(__self__, "download_direct", download_direct)
        if enable_cookie_management is not None:
            pulumi.set(__self__, "enable_cookie_management", enable_cookie_management)
        if excludes_pattern is not None:
            pulumi.set(__self__, "excludes_pattern", excludes_pattern)
        if hard_fail is not None:
            pulumi.set(__self__, "hard_fail", hard_fail)
        if includes_pattern is not None:
            pulumi.set(__self__, "includes_pattern", includes_pattern)
        if list_remote_folder_items is not None:
            pulumi.set(__self__, "list_remote_folder_items", list_remote_folder_items)
        if local_address is not None:
            pulumi.set(__self__, "local_address", local_address)
        if metadata_retrieval_timeout_secs is not None:
            pulumi.set(__self__, "metadata_retrieval_timeout_secs", metadata_retrieval_timeout_secs)
        if mismatching_mime_types_override_list is not None:
            pulumi.set(__self__, "mismatching_mime_types_override_list", mismatching_mime_types_override_list)
        if missed_cache_period_seconds is not None:
            pulumi.set(__self__, "missed_cache_period_seconds", missed_cache_period_seconds)
        if notes is not None:
            pulumi.set(__self__, "notes", notes)
        if offline is not None:
            pulumi.set(__self__, "offline", offline)
        if password is not None:
            pulumi.set(__self__, "password", password)
        if priority_resolution is not None:
            pulumi.set(__self__, "priority_resolution", priority_resolution)
        if project_environments is not None:
            pulumi.set(__self__, "project_environments", project_environments)
        if project_key is not None:
            pulumi.set(__self__, "project_key", project_key)
        if property_sets is not None:
            pulumi.set(__self__, "property_sets", property_sets)
        if proxy is not None:
            pulumi.set(__self__, "proxy", proxy)
        if query_params is not None:
            pulumi.set(__self__, "query_params", query_params)
        if remote_repo_layout_ref is not None:
            pulumi.set(__self__, "remote_repo_layout_ref", remote_repo_layout_ref)
        if repo_layout_ref is not None:
            pulumi.set(__self__, "repo_layout_ref", repo_layout_ref)
        if retrieval_cache_period_seconds is not None:
            pulumi.set(__self__, "retrieval_cache_period_seconds", retrieval_cache_period_seconds)
        if share_configuration is not None:
            warnings.warn("""No longer supported""", DeprecationWarning)
            pulumi.log.warn("""share_configuration is deprecated: No longer supported""")
        if share_configuration is not None:
            pulumi.set(__self__, "share_configuration", share_configuration)
        if socket_timeout_millis is not None:
            pulumi.set(__self__, "socket_timeout_millis", socket_timeout_millis)
        if store_artifacts_locally is not None:
            pulumi.set(__self__, "store_artifacts_locally", store_artifacts_locally)
        if synchronize_properties is not None:
            pulumi.set(__self__, "synchronize_properties", synchronize_properties)
        if unused_artifacts_cleanup_period_hours is not None:
            pulumi.set(__self__, "unused_artifacts_cleanup_period_hours", unused_artifacts_cleanup_period_hours)
        if url is not None:
            pulumi.set(__self__, "url", url)
        if username is not None:
            pulumi.set(__self__, "username", username)
        if xray_index is not None:
            pulumi.set(__self__, "xray_index", xray_index)

    @property
    @pulumi.getter
    def key(self) -> pulumi.Input[builtins.str]:
        """
        A mandatory identifier for the repository that must be unique. It cannot begin with a number or
        contain spaces or special characters.
        """
        return pulumi.get(self, "key")

    @key.setter
    def key(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "key", value)

    @property
    @pulumi.getter(name="allowAnyHostAuth")
    def allow_any_host_auth(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        'Lenient Host Authentication' in the UI. Allow credentials of this repository to be used on requests redirected to any
        other host.
        """
        return pulumi.get(self, "allow_any_host_auth")

    @allow_any_host_auth.setter
    def allow_any_host_auth(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "allow_any_host_auth", value)

    @property
    @pulumi.getter(name="archiveBrowsingEnabled")
    def archive_browsing_enabled(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        When set, you may view content such as HTML or Javadoc files directly from Artifactory. This may not be safe and
        therefore requires strict content moderation to prevent malicious users from uploading content that may compromise
        security (e.g., cross-site scripting attacks).
        """
        return pulumi.get(self, "archive_browsing_enabled")

    @archive_browsing_enabled.setter
    def archive_browsing_enabled(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "archive_browsing_enabled", value)

    @property
    @pulumi.getter(name="assumedOfflinePeriodSecs")
    def assumed_offline_period_secs(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        The number of seconds the repository stays in assumed offline state after a connection error. At the end of this time,
        an online check is attempted in order to reset the offline status. A value of 0 means the repository is never assumed
        offline.
        """
        return pulumi.get(self, "assumed_offline_period_secs")

    @assumed_offline_period_secs.setter
    def assumed_offline_period_secs(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "assumed_offline_period_secs", value)

    @property
    @pulumi.getter(name="blackedOut")
    def blacked_out(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        (A.K.A 'Ignore Repository' on the UI) When set, the repository or its local cache do not participate in artifact
        resolution.
        """
        return pulumi.get(self, "blacked_out")

    @blacked_out.setter
    def blacked_out(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "blacked_out", value)

    @property
    @pulumi.getter(name="blockMismatchingMimeTypes")
    def block_mismatching_mime_types(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        If set, artifacts will fail to download if a mismatch is detected between requested and received mimetype, according to
        the list specified in the system properties file under blockedMismatchingMimeTypes. You can override by adding mimetypes
        to the override list 'mismatching_mime_types_override_list'.
        """
        return pulumi.get(self, "block_mismatching_mime_types")

    @block_mismatching_mime_types.setter
    def block_mismatching_mime_types(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "block_mismatching_mime_types", value)

    @property
    @pulumi.getter(name="bypassHeadRequests")
    def bypass_head_requests(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Before caching an artifact, Artifactory first sends a HEAD request to the remote resource. In some remote resources,
        HEAD requests are disallowed and therefore rejected, even though downloading the artifact is allowed. When checked,
        Artifactory will bypass the HEAD request and cache the artifact directly using a GET request.
        """
        return pulumi.get(self, "bypass_head_requests")

    @bypass_head_requests.setter
    def bypass_head_requests(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "bypass_head_requests", value)

    @property
    @pulumi.getter(name="cdnRedirect")
    def cdn_redirect(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        When set, download requests to this repository will redirect the client to download the artifact directly from AWS
        CloudFront. Available in Enterprise+ and Edge licenses only. Default value is 'false'
        """
        return pulumi.get(self, "cdn_redirect")

    @cdn_redirect.setter
    def cdn_redirect(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "cdn_redirect", value)

    @property
    @pulumi.getter(name="clientTlsCertificate")
    def client_tls_certificate(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Client TLS certificate name.
        """
        return pulumi.get(self, "client_tls_certificate")

    @client_tls_certificate.setter
    def client_tls_certificate(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "client_tls_certificate", value)

    @property
    @pulumi.getter(name="contentSynchronisation")
    def content_synchronisation(self) -> Optional[pulumi.Input['RemoteAnsibleRepositoryContentSynchronisationArgs']]:
        return pulumi.get(self, "content_synchronisation")

    @content_synchronisation.setter
    def content_synchronisation(self, value: Optional[pulumi.Input['RemoteAnsibleRepositoryContentSynchronisationArgs']]):
        pulumi.set(self, "content_synchronisation", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Public description.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="disableProxy")
    def disable_proxy(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        When set to `true`, the proxy is disabled, and not returned in the API response body. If there is a default proxy set
        for the Artifactory instance, it will be ignored, too. Introduced since Artifactory 7.41.7.
        """
        return pulumi.get(self, "disable_proxy")

    @disable_proxy.setter
    def disable_proxy(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "disable_proxy", value)

    @property
    @pulumi.getter(name="disableUrlNormalization")
    def disable_url_normalization(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether to disable URL normalization. Default is `false`.
        """
        return pulumi.get(self, "disable_url_normalization")

    @disable_url_normalization.setter
    def disable_url_normalization(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "disable_url_normalization", value)

    @property
    @pulumi.getter(name="downloadDirect")
    def download_direct(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        When set, download requests to this repository will redirect the client to download the artifact directly from the cloud
        storage provider. Available in Enterprise+ and Edge licenses only. Default value is 'false'.
        """
        return pulumi.get(self, "download_direct")

    @download_direct.setter
    def download_direct(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "download_direct", value)

    @property
    @pulumi.getter(name="enableCookieManagement")
    def enable_cookie_management(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Enables cookie management if the remote repository uses cookies to manage client state.
        """
        return pulumi.get(self, "enable_cookie_management")

    @enable_cookie_management.setter
    def enable_cookie_management(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "enable_cookie_management", value)

    @property
    @pulumi.getter(name="excludesPattern")
    def excludes_pattern(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        List of artifact patterns to exclude when evaluating artifact requests, in the form of `x/y/**/z/*`.By default no
        artifacts are excluded.
        """
        return pulumi.get(self, "excludes_pattern")

    @excludes_pattern.setter
    def excludes_pattern(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "excludes_pattern", value)

    @property
    @pulumi.getter(name="hardFail")
    def hard_fail(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        When set, Artifactory will return an error to the client that causes the build to fail if there is a failure to
        communicate with this repository.
        """
        return pulumi.get(self, "hard_fail")

    @hard_fail.setter
    def hard_fail(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "hard_fail", value)

    @property
    @pulumi.getter(name="includesPattern")
    def includes_pattern(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        List of comma-separated artifact patterns to include when evaluating artifact requests in the form of `x/y/**/z/*`. When
        used, only artifacts matching one of the include patterns are served. By default, all artifacts are included (`**/*`).
        """
        return pulumi.get(self, "includes_pattern")

    @includes_pattern.setter
    def includes_pattern(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "includes_pattern", value)

    @property
    @pulumi.getter(name="listRemoteFolderItems")
    def list_remote_folder_items(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Lists the items of remote folders in simple and list browsing. The remote content is cached according to the value of
        the 'Retrieval Cache Period'. Default value is 'false'. This field exists in the API but not in the UI.
        """
        return pulumi.get(self, "list_remote_folder_items")

    @list_remote_folder_items.setter
    def list_remote_folder_items(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "list_remote_folder_items", value)

    @property
    @pulumi.getter(name="localAddress")
    def local_address(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The local address to be used when creating connections. Useful for specifying the interface to use on systems with
        multiple network interfaces.
        """
        return pulumi.get(self, "local_address")

    @local_address.setter
    def local_address(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "local_address", value)

    @property
    @pulumi.getter(name="metadataRetrievalTimeoutSecs")
    def metadata_retrieval_timeout_secs(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        Metadata Retrieval Cache Timeout (Sec) in the UI.This value refers to the number of seconds to wait for retrieval from
        the remote before serving locally cached artifact or fail the request.
        """
        return pulumi.get(self, "metadata_retrieval_timeout_secs")

    @metadata_retrieval_timeout_secs.setter
    def metadata_retrieval_timeout_secs(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "metadata_retrieval_timeout_secs", value)

    @property
    @pulumi.getter(name="mismatchingMimeTypesOverrideList")
    def mismatching_mime_types_override_list(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The set of mime types that should override the block_mismatching_mime_types setting. Eg:
        'application/json,application/xml'. Default value is empty.
        """
        return pulumi.get(self, "mismatching_mime_types_override_list")

    @mismatching_mime_types_override_list.setter
    def mismatching_mime_types_override_list(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "mismatching_mime_types_override_list", value)

    @property
    @pulumi.getter(name="missedCachePeriodSeconds")
    def missed_cache_period_seconds(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        Missed Retrieval Cache Period (Sec) in the UI. The number of seconds to cache artifact retrieval misses (artifact not
        found). A value of 0 indicates no caching.
        """
        return pulumi.get(self, "missed_cache_period_seconds")

    @missed_cache_period_seconds.setter
    def missed_cache_period_seconds(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "missed_cache_period_seconds", value)

    @property
    @pulumi.getter
    def notes(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Internal description.
        """
        return pulumi.get(self, "notes")

    @notes.setter
    def notes(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "notes", value)

    @property
    @pulumi.getter
    def offline(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        If set, Artifactory does not try to fetch remote artifacts. Only locally-cached artifacts are retrieved.
        """
        return pulumi.get(self, "offline")

    @offline.setter
    def offline(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "offline", value)

    @property
    @pulumi.getter
    def password(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "password")

    @password.setter
    def password(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "password", value)

    @property
    @pulumi.getter(name="priorityResolution")
    def priority_resolution(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Setting repositories with priority will cause metadata to be merged only from repositories set with this field
        """
        return pulumi.get(self, "priority_resolution")

    @priority_resolution.setter
    def priority_resolution(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "priority_resolution", value)

    @property
    @pulumi.getter(name="projectEnvironments")
    def project_environments(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        return pulumi.get(self, "project_environments")

    @project_environments.setter
    def project_environments(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "project_environments", value)

    @property
    @pulumi.getter(name="projectKey")
    def project_key(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Project key for assigning this repository to. Must be 2 - 32 lowercase alphanumeric and hyphen characters. When
        assigning repository to a project, repository key must be prefixed with project key, separated by a dash.
        """
        return pulumi.get(self, "project_key")

    @project_key.setter
    def project_key(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "project_key", value)

    @property
    @pulumi.getter(name="propertySets")
    def property_sets(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        List of property set name
        """
        return pulumi.get(self, "property_sets")

    @property_sets.setter
    def property_sets(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "property_sets", value)

    @property
    @pulumi.getter
    def proxy(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Proxy key from Artifactory Proxies settings. Can't be set if `disable_proxy = true`.
        """
        return pulumi.get(self, "proxy")

    @proxy.setter
    def proxy(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "proxy", value)

    @property
    @pulumi.getter(name="queryParams")
    def query_params(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Custom HTTP query parameters that will be automatically included in all remote resource requests. For example:
        `param1=val1&param2=val2&param3=val3`
        """
        return pulumi.get(self, "query_params")

    @query_params.setter
    def query_params(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "query_params", value)

    @property
    @pulumi.getter(name="remoteRepoLayoutRef")
    def remote_repo_layout_ref(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Repository layout key for the remote layout mapping. Repository can be created without this attribute (or set to an
        empty string). Once it's set, it can't be removed by passing an empty string or removing the attribute, that will be
        ignored by the Artifactory API. UI shows an error message, if the user tries to remove the value.
        """
        return pulumi.get(self, "remote_repo_layout_ref")

    @remote_repo_layout_ref.setter
    def remote_repo_layout_ref(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "remote_repo_layout_ref", value)

    @property
    @pulumi.getter(name="repoLayoutRef")
    def repo_layout_ref(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Sets the layout that the repository should use for storing and identifying modules. A recommended layout that
        corresponds to the package type defined is suggested, and index packages uploaded and calculate metadata accordingly.
        """
        return pulumi.get(self, "repo_layout_ref")

    @repo_layout_ref.setter
    def repo_layout_ref(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "repo_layout_ref", value)

    @property
    @pulumi.getter(name="retrievalCachePeriodSeconds")
    def retrieval_cache_period_seconds(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        Metadata Retrieval Cache Period (Sec) in the UI. This value refers to the number of seconds to cache metadata files
        before checking for newer versions on remote server. A value of 0 indicates no caching.
        """
        return pulumi.get(self, "retrieval_cache_period_seconds")

    @retrieval_cache_period_seconds.setter
    def retrieval_cache_period_seconds(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "retrieval_cache_period_seconds", value)

    @property
    @pulumi.getter(name="shareConfiguration")
    @_utilities.deprecated("""No longer supported""")
    def share_configuration(self) -> Optional[pulumi.Input[builtins.bool]]:
        return pulumi.get(self, "share_configuration")

    @share_configuration.setter
    def share_configuration(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "share_configuration", value)

    @property
    @pulumi.getter(name="socketTimeoutMillis")
    def socket_timeout_millis(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        Network timeout (in ms) to use when establishing a connection and for unanswered requests. Timing out on a network
        operation is considered a retrieval failure.
        """
        return pulumi.get(self, "socket_timeout_millis")

    @socket_timeout_millis.setter
    def socket_timeout_millis(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "socket_timeout_millis", value)

    @property
    @pulumi.getter(name="storeArtifactsLocally")
    def store_artifacts_locally(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        When set, the repository should store cached artifacts locally. When not set, artifacts are not stored locally, and
        direct repository-to-client streaming is used. This can be useful for multi-server setups over a high-speed LAN, with
        one Artifactory caching certain data on central storage, and streaming it directly to satellite pass-though Artifactory
        servers.
        """
        return pulumi.get(self, "store_artifacts_locally")

    @store_artifacts_locally.setter
    def store_artifacts_locally(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "store_artifacts_locally", value)

    @property
    @pulumi.getter(name="synchronizeProperties")
    def synchronize_properties(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        When set, remote artifacts are fetched along with their properties.
        """
        return pulumi.get(self, "synchronize_properties")

    @synchronize_properties.setter
    def synchronize_properties(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "synchronize_properties", value)

    @property
    @pulumi.getter(name="unusedArtifactsCleanupPeriodHours")
    def unused_artifacts_cleanup_period_hours(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        Unused Artifacts Cleanup Period (Hr) in the UI. The number of hours to wait before an artifact is deemed 'unused' and
        eligible for cleanup from the repository. A value of 0 means automatic cleanup of cached artifacts is disabled.
        """
        return pulumi.get(self, "unused_artifacts_cleanup_period_hours")

    @unused_artifacts_cleanup_period_hours.setter
    def unused_artifacts_cleanup_period_hours(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "unused_artifacts_cleanup_period_hours", value)

    @property
    @pulumi.getter
    def url(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The remote repo URL.
        """
        return pulumi.get(self, "url")

    @url.setter
    def url(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "url", value)

    @property
    @pulumi.getter
    def username(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "username")

    @username.setter
    def username(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "username", value)

    @property
    @pulumi.getter(name="xrayIndex")
    def xray_index(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Enable Indexing In Xray. Repository will be indexed with the default retention period. You will be able to change it via
        Xray settings.
        """
        return pulumi.get(self, "xray_index")

    @xray_index.setter
    def xray_index(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "xray_index", value)


@pulumi.input_type
class _RemoteAnsibleRepositoryState:
    def __init__(__self__, *,
                 allow_any_host_auth: Optional[pulumi.Input[builtins.bool]] = None,
                 archive_browsing_enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 assumed_offline_period_secs: Optional[pulumi.Input[builtins.int]] = None,
                 blacked_out: Optional[pulumi.Input[builtins.bool]] = None,
                 block_mismatching_mime_types: Optional[pulumi.Input[builtins.bool]] = None,
                 bypass_head_requests: Optional[pulumi.Input[builtins.bool]] = None,
                 cdn_redirect: Optional[pulumi.Input[builtins.bool]] = None,
                 client_tls_certificate: Optional[pulumi.Input[builtins.str]] = None,
                 content_synchronisation: Optional[pulumi.Input['RemoteAnsibleRepositoryContentSynchronisationArgs']] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 disable_proxy: Optional[pulumi.Input[builtins.bool]] = None,
                 disable_url_normalization: Optional[pulumi.Input[builtins.bool]] = None,
                 download_direct: Optional[pulumi.Input[builtins.bool]] = None,
                 enable_cookie_management: Optional[pulumi.Input[builtins.bool]] = None,
                 excludes_pattern: Optional[pulumi.Input[builtins.str]] = None,
                 hard_fail: Optional[pulumi.Input[builtins.bool]] = None,
                 includes_pattern: Optional[pulumi.Input[builtins.str]] = None,
                 key: Optional[pulumi.Input[builtins.str]] = None,
                 list_remote_folder_items: Optional[pulumi.Input[builtins.bool]] = None,
                 local_address: Optional[pulumi.Input[builtins.str]] = None,
                 metadata_retrieval_timeout_secs: Optional[pulumi.Input[builtins.int]] = None,
                 mismatching_mime_types_override_list: Optional[pulumi.Input[builtins.str]] = None,
                 missed_cache_period_seconds: Optional[pulumi.Input[builtins.int]] = None,
                 notes: Optional[pulumi.Input[builtins.str]] = None,
                 offline: Optional[pulumi.Input[builtins.bool]] = None,
                 password: Optional[pulumi.Input[builtins.str]] = None,
                 priority_resolution: Optional[pulumi.Input[builtins.bool]] = None,
                 project_environments: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 project_key: Optional[pulumi.Input[builtins.str]] = None,
                 property_sets: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 proxy: Optional[pulumi.Input[builtins.str]] = None,
                 query_params: Optional[pulumi.Input[builtins.str]] = None,
                 remote_repo_layout_ref: Optional[pulumi.Input[builtins.str]] = None,
                 repo_layout_ref: Optional[pulumi.Input[builtins.str]] = None,
                 retrieval_cache_period_seconds: Optional[pulumi.Input[builtins.int]] = None,
                 share_configuration: Optional[pulumi.Input[builtins.bool]] = None,
                 socket_timeout_millis: Optional[pulumi.Input[builtins.int]] = None,
                 store_artifacts_locally: Optional[pulumi.Input[builtins.bool]] = None,
                 synchronize_properties: Optional[pulumi.Input[builtins.bool]] = None,
                 unused_artifacts_cleanup_period_hours: Optional[pulumi.Input[builtins.int]] = None,
                 url: Optional[pulumi.Input[builtins.str]] = None,
                 username: Optional[pulumi.Input[builtins.str]] = None,
                 xray_index: Optional[pulumi.Input[builtins.bool]] = None):
        """
        Input properties used for looking up and filtering RemoteAnsibleRepository resources.
        :param pulumi.Input[builtins.bool] allow_any_host_auth: 'Lenient Host Authentication' in the UI. Allow credentials of this repository to be used on requests redirected to any
               other host.
        :param pulumi.Input[builtins.bool] archive_browsing_enabled: When set, you may view content such as HTML or Javadoc files directly from Artifactory. This may not be safe and
               therefore requires strict content moderation to prevent malicious users from uploading content that may compromise
               security (e.g., cross-site scripting attacks).
        :param pulumi.Input[builtins.int] assumed_offline_period_secs: The number of seconds the repository stays in assumed offline state after a connection error. At the end of this time,
               an online check is attempted in order to reset the offline status. A value of 0 means the repository is never assumed
               offline.
        :param pulumi.Input[builtins.bool] blacked_out: (A.K.A 'Ignore Repository' on the UI) When set, the repository or its local cache do not participate in artifact
               resolution.
        :param pulumi.Input[builtins.bool] block_mismatching_mime_types: If set, artifacts will fail to download if a mismatch is detected between requested and received mimetype, according to
               the list specified in the system properties file under blockedMismatchingMimeTypes. You can override by adding mimetypes
               to the override list 'mismatching_mime_types_override_list'.
        :param pulumi.Input[builtins.bool] bypass_head_requests: Before caching an artifact, Artifactory first sends a HEAD request to the remote resource. In some remote resources,
               HEAD requests are disallowed and therefore rejected, even though downloading the artifact is allowed. When checked,
               Artifactory will bypass the HEAD request and cache the artifact directly using a GET request.
        :param pulumi.Input[builtins.bool] cdn_redirect: When set, download requests to this repository will redirect the client to download the artifact directly from AWS
               CloudFront. Available in Enterprise+ and Edge licenses only. Default value is 'false'
        :param pulumi.Input[builtins.str] client_tls_certificate: Client TLS certificate name.
        :param pulumi.Input[builtins.str] description: Public description.
        :param pulumi.Input[builtins.bool] disable_proxy: When set to `true`, the proxy is disabled, and not returned in the API response body. If there is a default proxy set
               for the Artifactory instance, it will be ignored, too. Introduced since Artifactory 7.41.7.
        :param pulumi.Input[builtins.bool] disable_url_normalization: Whether to disable URL normalization. Default is `false`.
        :param pulumi.Input[builtins.bool] download_direct: When set, download requests to this repository will redirect the client to download the artifact directly from the cloud
               storage provider. Available in Enterprise+ and Edge licenses only. Default value is 'false'.
        :param pulumi.Input[builtins.bool] enable_cookie_management: Enables cookie management if the remote repository uses cookies to manage client state.
        :param pulumi.Input[builtins.str] excludes_pattern: List of artifact patterns to exclude when evaluating artifact requests, in the form of `x/y/**/z/*`.By default no
               artifacts are excluded.
        :param pulumi.Input[builtins.bool] hard_fail: When set, Artifactory will return an error to the client that causes the build to fail if there is a failure to
               communicate with this repository.
        :param pulumi.Input[builtins.str] includes_pattern: List of comma-separated artifact patterns to include when evaluating artifact requests in the form of `x/y/**/z/*`. When
               used, only artifacts matching one of the include patterns are served. By default, all artifacts are included (`**/*`).
        :param pulumi.Input[builtins.str] key: A mandatory identifier for the repository that must be unique. It cannot begin with a number or
               contain spaces or special characters.
        :param pulumi.Input[builtins.bool] list_remote_folder_items: Lists the items of remote folders in simple and list browsing. The remote content is cached according to the value of
               the 'Retrieval Cache Period'. Default value is 'false'. This field exists in the API but not in the UI.
        :param pulumi.Input[builtins.str] local_address: The local address to be used when creating connections. Useful for specifying the interface to use on systems with
               multiple network interfaces.
        :param pulumi.Input[builtins.int] metadata_retrieval_timeout_secs: Metadata Retrieval Cache Timeout (Sec) in the UI.This value refers to the number of seconds to wait for retrieval from
               the remote before serving locally cached artifact or fail the request.
        :param pulumi.Input[builtins.str] mismatching_mime_types_override_list: The set of mime types that should override the block_mismatching_mime_types setting. Eg:
               'application/json,application/xml'. Default value is empty.
        :param pulumi.Input[builtins.int] missed_cache_period_seconds: Missed Retrieval Cache Period (Sec) in the UI. The number of seconds to cache artifact retrieval misses (artifact not
               found). A value of 0 indicates no caching.
        :param pulumi.Input[builtins.str] notes: Internal description.
        :param pulumi.Input[builtins.bool] offline: If set, Artifactory does not try to fetch remote artifacts. Only locally-cached artifacts are retrieved.
        :param pulumi.Input[builtins.bool] priority_resolution: Setting repositories with priority will cause metadata to be merged only from repositories set with this field
        :param pulumi.Input[builtins.str] project_key: Project key for assigning this repository to. Must be 2 - 32 lowercase alphanumeric and hyphen characters. When
               assigning repository to a project, repository key must be prefixed with project key, separated by a dash.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] property_sets: List of property set name
        :param pulumi.Input[builtins.str] proxy: Proxy key from Artifactory Proxies settings. Can't be set if `disable_proxy = true`.
        :param pulumi.Input[builtins.str] query_params: Custom HTTP query parameters that will be automatically included in all remote resource requests. For example:
               `param1=val1&param2=val2&param3=val3`
        :param pulumi.Input[builtins.str] remote_repo_layout_ref: Repository layout key for the remote layout mapping. Repository can be created without this attribute (or set to an
               empty string). Once it's set, it can't be removed by passing an empty string or removing the attribute, that will be
               ignored by the Artifactory API. UI shows an error message, if the user tries to remove the value.
        :param pulumi.Input[builtins.str] repo_layout_ref: Sets the layout that the repository should use for storing and identifying modules. A recommended layout that
               corresponds to the package type defined is suggested, and index packages uploaded and calculate metadata accordingly.
        :param pulumi.Input[builtins.int] retrieval_cache_period_seconds: Metadata Retrieval Cache Period (Sec) in the UI. This value refers to the number of seconds to cache metadata files
               before checking for newer versions on remote server. A value of 0 indicates no caching.
        :param pulumi.Input[builtins.int] socket_timeout_millis: Network timeout (in ms) to use when establishing a connection and for unanswered requests. Timing out on a network
               operation is considered a retrieval failure.
        :param pulumi.Input[builtins.bool] store_artifacts_locally: When set, the repository should store cached artifacts locally. When not set, artifacts are not stored locally, and
               direct repository-to-client streaming is used. This can be useful for multi-server setups over a high-speed LAN, with
               one Artifactory caching certain data on central storage, and streaming it directly to satellite pass-though Artifactory
               servers.
        :param pulumi.Input[builtins.bool] synchronize_properties: When set, remote artifacts are fetched along with their properties.
        :param pulumi.Input[builtins.int] unused_artifacts_cleanup_period_hours: Unused Artifacts Cleanup Period (Hr) in the UI. The number of hours to wait before an artifact is deemed 'unused' and
               eligible for cleanup from the repository. A value of 0 means automatic cleanup of cached artifacts is disabled.
        :param pulumi.Input[builtins.str] url: The remote repo URL.
        :param pulumi.Input[builtins.bool] xray_index: Enable Indexing In Xray. Repository will be indexed with the default retention period. You will be able to change it via
               Xray settings.
        """
        if allow_any_host_auth is not None:
            pulumi.set(__self__, "allow_any_host_auth", allow_any_host_auth)
        if archive_browsing_enabled is not None:
            pulumi.set(__self__, "archive_browsing_enabled", archive_browsing_enabled)
        if assumed_offline_period_secs is not None:
            pulumi.set(__self__, "assumed_offline_period_secs", assumed_offline_period_secs)
        if blacked_out is not None:
            pulumi.set(__self__, "blacked_out", blacked_out)
        if block_mismatching_mime_types is not None:
            pulumi.set(__self__, "block_mismatching_mime_types", block_mismatching_mime_types)
        if bypass_head_requests is not None:
            pulumi.set(__self__, "bypass_head_requests", bypass_head_requests)
        if cdn_redirect is not None:
            pulumi.set(__self__, "cdn_redirect", cdn_redirect)
        if client_tls_certificate is not None:
            pulumi.set(__self__, "client_tls_certificate", client_tls_certificate)
        if content_synchronisation is not None:
            pulumi.set(__self__, "content_synchronisation", content_synchronisation)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if disable_proxy is not None:
            pulumi.set(__self__, "disable_proxy", disable_proxy)
        if disable_url_normalization is not None:
            pulumi.set(__self__, "disable_url_normalization", disable_url_normalization)
        if download_direct is not None:
            pulumi.set(__self__, "download_direct", download_direct)
        if enable_cookie_management is not None:
            pulumi.set(__self__, "enable_cookie_management", enable_cookie_management)
        if excludes_pattern is not None:
            pulumi.set(__self__, "excludes_pattern", excludes_pattern)
        if hard_fail is not None:
            pulumi.set(__self__, "hard_fail", hard_fail)
        if includes_pattern is not None:
            pulumi.set(__self__, "includes_pattern", includes_pattern)
        if key is not None:
            pulumi.set(__self__, "key", key)
        if list_remote_folder_items is not None:
            pulumi.set(__self__, "list_remote_folder_items", list_remote_folder_items)
        if local_address is not None:
            pulumi.set(__self__, "local_address", local_address)
        if metadata_retrieval_timeout_secs is not None:
            pulumi.set(__self__, "metadata_retrieval_timeout_secs", metadata_retrieval_timeout_secs)
        if mismatching_mime_types_override_list is not None:
            pulumi.set(__self__, "mismatching_mime_types_override_list", mismatching_mime_types_override_list)
        if missed_cache_period_seconds is not None:
            pulumi.set(__self__, "missed_cache_period_seconds", missed_cache_period_seconds)
        if notes is not None:
            pulumi.set(__self__, "notes", notes)
        if offline is not None:
            pulumi.set(__self__, "offline", offline)
        if password is not None:
            pulumi.set(__self__, "password", password)
        if priority_resolution is not None:
            pulumi.set(__self__, "priority_resolution", priority_resolution)
        if project_environments is not None:
            pulumi.set(__self__, "project_environments", project_environments)
        if project_key is not None:
            pulumi.set(__self__, "project_key", project_key)
        if property_sets is not None:
            pulumi.set(__self__, "property_sets", property_sets)
        if proxy is not None:
            pulumi.set(__self__, "proxy", proxy)
        if query_params is not None:
            pulumi.set(__self__, "query_params", query_params)
        if remote_repo_layout_ref is not None:
            pulumi.set(__self__, "remote_repo_layout_ref", remote_repo_layout_ref)
        if repo_layout_ref is not None:
            pulumi.set(__self__, "repo_layout_ref", repo_layout_ref)
        if retrieval_cache_period_seconds is not None:
            pulumi.set(__self__, "retrieval_cache_period_seconds", retrieval_cache_period_seconds)
        if share_configuration is not None:
            warnings.warn("""No longer supported""", DeprecationWarning)
            pulumi.log.warn("""share_configuration is deprecated: No longer supported""")
        if share_configuration is not None:
            pulumi.set(__self__, "share_configuration", share_configuration)
        if socket_timeout_millis is not None:
            pulumi.set(__self__, "socket_timeout_millis", socket_timeout_millis)
        if store_artifacts_locally is not None:
            pulumi.set(__self__, "store_artifacts_locally", store_artifacts_locally)
        if synchronize_properties is not None:
            pulumi.set(__self__, "synchronize_properties", synchronize_properties)
        if unused_artifacts_cleanup_period_hours is not None:
            pulumi.set(__self__, "unused_artifacts_cleanup_period_hours", unused_artifacts_cleanup_period_hours)
        if url is not None:
            pulumi.set(__self__, "url", url)
        if username is not None:
            pulumi.set(__self__, "username", username)
        if xray_index is not None:
            pulumi.set(__self__, "xray_index", xray_index)

    @property
    @pulumi.getter(name="allowAnyHostAuth")
    def allow_any_host_auth(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        'Lenient Host Authentication' in the UI. Allow credentials of this repository to be used on requests redirected to any
        other host.
        """
        return pulumi.get(self, "allow_any_host_auth")

    @allow_any_host_auth.setter
    def allow_any_host_auth(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "allow_any_host_auth", value)

    @property
    @pulumi.getter(name="archiveBrowsingEnabled")
    def archive_browsing_enabled(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        When set, you may view content such as HTML or Javadoc files directly from Artifactory. This may not be safe and
        therefore requires strict content moderation to prevent malicious users from uploading content that may compromise
        security (e.g., cross-site scripting attacks).
        """
        return pulumi.get(self, "archive_browsing_enabled")

    @archive_browsing_enabled.setter
    def archive_browsing_enabled(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "archive_browsing_enabled", value)

    @property
    @pulumi.getter(name="assumedOfflinePeriodSecs")
    def assumed_offline_period_secs(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        The number of seconds the repository stays in assumed offline state after a connection error. At the end of this time,
        an online check is attempted in order to reset the offline status. A value of 0 means the repository is never assumed
        offline.
        """
        return pulumi.get(self, "assumed_offline_period_secs")

    @assumed_offline_period_secs.setter
    def assumed_offline_period_secs(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "assumed_offline_period_secs", value)

    @property
    @pulumi.getter(name="blackedOut")
    def blacked_out(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        (A.K.A 'Ignore Repository' on the UI) When set, the repository or its local cache do not participate in artifact
        resolution.
        """
        return pulumi.get(self, "blacked_out")

    @blacked_out.setter
    def blacked_out(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "blacked_out", value)

    @property
    @pulumi.getter(name="blockMismatchingMimeTypes")
    def block_mismatching_mime_types(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        If set, artifacts will fail to download if a mismatch is detected between requested and received mimetype, according to
        the list specified in the system properties file under blockedMismatchingMimeTypes. You can override by adding mimetypes
        to the override list 'mismatching_mime_types_override_list'.
        """
        return pulumi.get(self, "block_mismatching_mime_types")

    @block_mismatching_mime_types.setter
    def block_mismatching_mime_types(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "block_mismatching_mime_types", value)

    @property
    @pulumi.getter(name="bypassHeadRequests")
    def bypass_head_requests(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Before caching an artifact, Artifactory first sends a HEAD request to the remote resource. In some remote resources,
        HEAD requests are disallowed and therefore rejected, even though downloading the artifact is allowed. When checked,
        Artifactory will bypass the HEAD request and cache the artifact directly using a GET request.
        """
        return pulumi.get(self, "bypass_head_requests")

    @bypass_head_requests.setter
    def bypass_head_requests(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "bypass_head_requests", value)

    @property
    @pulumi.getter(name="cdnRedirect")
    def cdn_redirect(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        When set, download requests to this repository will redirect the client to download the artifact directly from AWS
        CloudFront. Available in Enterprise+ and Edge licenses only. Default value is 'false'
        """
        return pulumi.get(self, "cdn_redirect")

    @cdn_redirect.setter
    def cdn_redirect(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "cdn_redirect", value)

    @property
    @pulumi.getter(name="clientTlsCertificate")
    def client_tls_certificate(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Client TLS certificate name.
        """
        return pulumi.get(self, "client_tls_certificate")

    @client_tls_certificate.setter
    def client_tls_certificate(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "client_tls_certificate", value)

    @property
    @pulumi.getter(name="contentSynchronisation")
    def content_synchronisation(self) -> Optional[pulumi.Input['RemoteAnsibleRepositoryContentSynchronisationArgs']]:
        return pulumi.get(self, "content_synchronisation")

    @content_synchronisation.setter
    def content_synchronisation(self, value: Optional[pulumi.Input['RemoteAnsibleRepositoryContentSynchronisationArgs']]):
        pulumi.set(self, "content_synchronisation", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Public description.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="disableProxy")
    def disable_proxy(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        When set to `true`, the proxy is disabled, and not returned in the API response body. If there is a default proxy set
        for the Artifactory instance, it will be ignored, too. Introduced since Artifactory 7.41.7.
        """
        return pulumi.get(self, "disable_proxy")

    @disable_proxy.setter
    def disable_proxy(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "disable_proxy", value)

    @property
    @pulumi.getter(name="disableUrlNormalization")
    def disable_url_normalization(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether to disable URL normalization. Default is `false`.
        """
        return pulumi.get(self, "disable_url_normalization")

    @disable_url_normalization.setter
    def disable_url_normalization(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "disable_url_normalization", value)

    @property
    @pulumi.getter(name="downloadDirect")
    def download_direct(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        When set, download requests to this repository will redirect the client to download the artifact directly from the cloud
        storage provider. Available in Enterprise+ and Edge licenses only. Default value is 'false'.
        """
        return pulumi.get(self, "download_direct")

    @download_direct.setter
    def download_direct(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "download_direct", value)

    @property
    @pulumi.getter(name="enableCookieManagement")
    def enable_cookie_management(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Enables cookie management if the remote repository uses cookies to manage client state.
        """
        return pulumi.get(self, "enable_cookie_management")

    @enable_cookie_management.setter
    def enable_cookie_management(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "enable_cookie_management", value)

    @property
    @pulumi.getter(name="excludesPattern")
    def excludes_pattern(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        List of artifact patterns to exclude when evaluating artifact requests, in the form of `x/y/**/z/*`.By default no
        artifacts are excluded.
        """
        return pulumi.get(self, "excludes_pattern")

    @excludes_pattern.setter
    def excludes_pattern(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "excludes_pattern", value)

    @property
    @pulumi.getter(name="hardFail")
    def hard_fail(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        When set, Artifactory will return an error to the client that causes the build to fail if there is a failure to
        communicate with this repository.
        """
        return pulumi.get(self, "hard_fail")

    @hard_fail.setter
    def hard_fail(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "hard_fail", value)

    @property
    @pulumi.getter(name="includesPattern")
    def includes_pattern(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        List of comma-separated artifact patterns to include when evaluating artifact requests in the form of `x/y/**/z/*`. When
        used, only artifacts matching one of the include patterns are served. By default, all artifacts are included (`**/*`).
        """
        return pulumi.get(self, "includes_pattern")

    @includes_pattern.setter
    def includes_pattern(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "includes_pattern", value)

    @property
    @pulumi.getter
    def key(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        A mandatory identifier for the repository that must be unique. It cannot begin with a number or
        contain spaces or special characters.
        """
        return pulumi.get(self, "key")

    @key.setter
    def key(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "key", value)

    @property
    @pulumi.getter(name="listRemoteFolderItems")
    def list_remote_folder_items(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Lists the items of remote folders in simple and list browsing. The remote content is cached according to the value of
        the 'Retrieval Cache Period'. Default value is 'false'. This field exists in the API but not in the UI.
        """
        return pulumi.get(self, "list_remote_folder_items")

    @list_remote_folder_items.setter
    def list_remote_folder_items(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "list_remote_folder_items", value)

    @property
    @pulumi.getter(name="localAddress")
    def local_address(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The local address to be used when creating connections. Useful for specifying the interface to use on systems with
        multiple network interfaces.
        """
        return pulumi.get(self, "local_address")

    @local_address.setter
    def local_address(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "local_address", value)

    @property
    @pulumi.getter(name="metadataRetrievalTimeoutSecs")
    def metadata_retrieval_timeout_secs(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        Metadata Retrieval Cache Timeout (Sec) in the UI.This value refers to the number of seconds to wait for retrieval from
        the remote before serving locally cached artifact or fail the request.
        """
        return pulumi.get(self, "metadata_retrieval_timeout_secs")

    @metadata_retrieval_timeout_secs.setter
    def metadata_retrieval_timeout_secs(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "metadata_retrieval_timeout_secs", value)

    @property
    @pulumi.getter(name="mismatchingMimeTypesOverrideList")
    def mismatching_mime_types_override_list(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The set of mime types that should override the block_mismatching_mime_types setting. Eg:
        'application/json,application/xml'. Default value is empty.
        """
        return pulumi.get(self, "mismatching_mime_types_override_list")

    @mismatching_mime_types_override_list.setter
    def mismatching_mime_types_override_list(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "mismatching_mime_types_override_list", value)

    @property
    @pulumi.getter(name="missedCachePeriodSeconds")
    def missed_cache_period_seconds(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        Missed Retrieval Cache Period (Sec) in the UI. The number of seconds to cache artifact retrieval misses (artifact not
        found). A value of 0 indicates no caching.
        """
        return pulumi.get(self, "missed_cache_period_seconds")

    @missed_cache_period_seconds.setter
    def missed_cache_period_seconds(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "missed_cache_period_seconds", value)

    @property
    @pulumi.getter
    def notes(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Internal description.
        """
        return pulumi.get(self, "notes")

    @notes.setter
    def notes(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "notes", value)

    @property
    @pulumi.getter
    def offline(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        If set, Artifactory does not try to fetch remote artifacts. Only locally-cached artifacts are retrieved.
        """
        return pulumi.get(self, "offline")

    @offline.setter
    def offline(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "offline", value)

    @property
    @pulumi.getter
    def password(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "password")

    @password.setter
    def password(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "password", value)

    @property
    @pulumi.getter(name="priorityResolution")
    def priority_resolution(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Setting repositories with priority will cause metadata to be merged only from repositories set with this field
        """
        return pulumi.get(self, "priority_resolution")

    @priority_resolution.setter
    def priority_resolution(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "priority_resolution", value)

    @property
    @pulumi.getter(name="projectEnvironments")
    def project_environments(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        return pulumi.get(self, "project_environments")

    @project_environments.setter
    def project_environments(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "project_environments", value)

    @property
    @pulumi.getter(name="projectKey")
    def project_key(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Project key for assigning this repository to. Must be 2 - 32 lowercase alphanumeric and hyphen characters. When
        assigning repository to a project, repository key must be prefixed with project key, separated by a dash.
        """
        return pulumi.get(self, "project_key")

    @project_key.setter
    def project_key(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "project_key", value)

    @property
    @pulumi.getter(name="propertySets")
    def property_sets(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        List of property set name
        """
        return pulumi.get(self, "property_sets")

    @property_sets.setter
    def property_sets(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "property_sets", value)

    @property
    @pulumi.getter
    def proxy(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Proxy key from Artifactory Proxies settings. Can't be set if `disable_proxy = true`.
        """
        return pulumi.get(self, "proxy")

    @proxy.setter
    def proxy(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "proxy", value)

    @property
    @pulumi.getter(name="queryParams")
    def query_params(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Custom HTTP query parameters that will be automatically included in all remote resource requests. For example:
        `param1=val1&param2=val2&param3=val3`
        """
        return pulumi.get(self, "query_params")

    @query_params.setter
    def query_params(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "query_params", value)

    @property
    @pulumi.getter(name="remoteRepoLayoutRef")
    def remote_repo_layout_ref(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Repository layout key for the remote layout mapping. Repository can be created without this attribute (or set to an
        empty string). Once it's set, it can't be removed by passing an empty string or removing the attribute, that will be
        ignored by the Artifactory API. UI shows an error message, if the user tries to remove the value.
        """
        return pulumi.get(self, "remote_repo_layout_ref")

    @remote_repo_layout_ref.setter
    def remote_repo_layout_ref(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "remote_repo_layout_ref", value)

    @property
    @pulumi.getter(name="repoLayoutRef")
    def repo_layout_ref(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Sets the layout that the repository should use for storing and identifying modules. A recommended layout that
        corresponds to the package type defined is suggested, and index packages uploaded and calculate metadata accordingly.
        """
        return pulumi.get(self, "repo_layout_ref")

    @repo_layout_ref.setter
    def repo_layout_ref(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "repo_layout_ref", value)

    @property
    @pulumi.getter(name="retrievalCachePeriodSeconds")
    def retrieval_cache_period_seconds(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        Metadata Retrieval Cache Period (Sec) in the UI. This value refers to the number of seconds to cache metadata files
        before checking for newer versions on remote server. A value of 0 indicates no caching.
        """
        return pulumi.get(self, "retrieval_cache_period_seconds")

    @retrieval_cache_period_seconds.setter
    def retrieval_cache_period_seconds(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "retrieval_cache_period_seconds", value)

    @property
    @pulumi.getter(name="shareConfiguration")
    @_utilities.deprecated("""No longer supported""")
    def share_configuration(self) -> Optional[pulumi.Input[builtins.bool]]:
        return pulumi.get(self, "share_configuration")

    @share_configuration.setter
    def share_configuration(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "share_configuration", value)

    @property
    @pulumi.getter(name="socketTimeoutMillis")
    def socket_timeout_millis(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        Network timeout (in ms) to use when establishing a connection and for unanswered requests. Timing out on a network
        operation is considered a retrieval failure.
        """
        return pulumi.get(self, "socket_timeout_millis")

    @socket_timeout_millis.setter
    def socket_timeout_millis(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "socket_timeout_millis", value)

    @property
    @pulumi.getter(name="storeArtifactsLocally")
    def store_artifacts_locally(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        When set, the repository should store cached artifacts locally. When not set, artifacts are not stored locally, and
        direct repository-to-client streaming is used. This can be useful for multi-server setups over a high-speed LAN, with
        one Artifactory caching certain data on central storage, and streaming it directly to satellite pass-though Artifactory
        servers.
        """
        return pulumi.get(self, "store_artifacts_locally")

    @store_artifacts_locally.setter
    def store_artifacts_locally(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "store_artifacts_locally", value)

    @property
    @pulumi.getter(name="synchronizeProperties")
    def synchronize_properties(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        When set, remote artifacts are fetched along with their properties.
        """
        return pulumi.get(self, "synchronize_properties")

    @synchronize_properties.setter
    def synchronize_properties(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "synchronize_properties", value)

    @property
    @pulumi.getter(name="unusedArtifactsCleanupPeriodHours")
    def unused_artifacts_cleanup_period_hours(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        Unused Artifacts Cleanup Period (Hr) in the UI. The number of hours to wait before an artifact is deemed 'unused' and
        eligible for cleanup from the repository. A value of 0 means automatic cleanup of cached artifacts is disabled.
        """
        return pulumi.get(self, "unused_artifacts_cleanup_period_hours")

    @unused_artifacts_cleanup_period_hours.setter
    def unused_artifacts_cleanup_period_hours(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "unused_artifacts_cleanup_period_hours", value)

    @property
    @pulumi.getter
    def url(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The remote repo URL.
        """
        return pulumi.get(self, "url")

    @url.setter
    def url(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "url", value)

    @property
    @pulumi.getter
    def username(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "username")

    @username.setter
    def username(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "username", value)

    @property
    @pulumi.getter(name="xrayIndex")
    def xray_index(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Enable Indexing In Xray. Repository will be indexed with the default retention period. You will be able to change it via
        Xray settings.
        """
        return pulumi.get(self, "xray_index")

    @xray_index.setter
    def xray_index(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "xray_index", value)


class RemoteAnsibleRepository(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 allow_any_host_auth: Optional[pulumi.Input[builtins.bool]] = None,
                 archive_browsing_enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 assumed_offline_period_secs: Optional[pulumi.Input[builtins.int]] = None,
                 blacked_out: Optional[pulumi.Input[builtins.bool]] = None,
                 block_mismatching_mime_types: Optional[pulumi.Input[builtins.bool]] = None,
                 bypass_head_requests: Optional[pulumi.Input[builtins.bool]] = None,
                 cdn_redirect: Optional[pulumi.Input[builtins.bool]] = None,
                 client_tls_certificate: Optional[pulumi.Input[builtins.str]] = None,
                 content_synchronisation: Optional[pulumi.Input[Union['RemoteAnsibleRepositoryContentSynchronisationArgs', 'RemoteAnsibleRepositoryContentSynchronisationArgsDict']]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 disable_proxy: Optional[pulumi.Input[builtins.bool]] = None,
                 disable_url_normalization: Optional[pulumi.Input[builtins.bool]] = None,
                 download_direct: Optional[pulumi.Input[builtins.bool]] = None,
                 enable_cookie_management: Optional[pulumi.Input[builtins.bool]] = None,
                 excludes_pattern: Optional[pulumi.Input[builtins.str]] = None,
                 hard_fail: Optional[pulumi.Input[builtins.bool]] = None,
                 includes_pattern: Optional[pulumi.Input[builtins.str]] = None,
                 key: Optional[pulumi.Input[builtins.str]] = None,
                 list_remote_folder_items: Optional[pulumi.Input[builtins.bool]] = None,
                 local_address: Optional[pulumi.Input[builtins.str]] = None,
                 metadata_retrieval_timeout_secs: Optional[pulumi.Input[builtins.int]] = None,
                 mismatching_mime_types_override_list: Optional[pulumi.Input[builtins.str]] = None,
                 missed_cache_period_seconds: Optional[pulumi.Input[builtins.int]] = None,
                 notes: Optional[pulumi.Input[builtins.str]] = None,
                 offline: Optional[pulumi.Input[builtins.bool]] = None,
                 password: Optional[pulumi.Input[builtins.str]] = None,
                 priority_resolution: Optional[pulumi.Input[builtins.bool]] = None,
                 project_environments: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 project_key: Optional[pulumi.Input[builtins.str]] = None,
                 property_sets: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 proxy: Optional[pulumi.Input[builtins.str]] = None,
                 query_params: Optional[pulumi.Input[builtins.str]] = None,
                 remote_repo_layout_ref: Optional[pulumi.Input[builtins.str]] = None,
                 repo_layout_ref: Optional[pulumi.Input[builtins.str]] = None,
                 retrieval_cache_period_seconds: Optional[pulumi.Input[builtins.int]] = None,
                 share_configuration: Optional[pulumi.Input[builtins.bool]] = None,
                 socket_timeout_millis: Optional[pulumi.Input[builtins.int]] = None,
                 store_artifacts_locally: Optional[pulumi.Input[builtins.bool]] = None,
                 synchronize_properties: Optional[pulumi.Input[builtins.bool]] = None,
                 unused_artifacts_cleanup_period_hours: Optional[pulumi.Input[builtins.int]] = None,
                 url: Optional[pulumi.Input[builtins.str]] = None,
                 username: Optional[pulumi.Input[builtins.str]] = None,
                 xray_index: Optional[pulumi.Input[builtins.bool]] = None,
                 __props__=None):
        """
        Creates a remote Ansible repository.

        Official documentation can be found [here](https://jfrog.com/help/r/jfrog-artifactory-documentation/ansible-repositories).

        ## Example Usage

        ```python
        import pulumi
        import pulumi_artifactory as artifactory

        my_remote_ansible = artifactory.RemoteAlpineRepository("my-remote-ansible",
            key="my-remote-ansible",
            url="https://galaxy.ansible.com")
        ```

        ## Import

        Remote repositories can be imported using their name, e.g.

        ```sh
        $ pulumi import artifactory:index/remoteAnsibleRepository:RemoteAnsibleRepository my-remote-ansible my-remote-ansible
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.bool] allow_any_host_auth: 'Lenient Host Authentication' in the UI. Allow credentials of this repository to be used on requests redirected to any
               other host.
        :param pulumi.Input[builtins.bool] archive_browsing_enabled: When set, you may view content such as HTML or Javadoc files directly from Artifactory. This may not be safe and
               therefore requires strict content moderation to prevent malicious users from uploading content that may compromise
               security (e.g., cross-site scripting attacks).
        :param pulumi.Input[builtins.int] assumed_offline_period_secs: The number of seconds the repository stays in assumed offline state after a connection error. At the end of this time,
               an online check is attempted in order to reset the offline status. A value of 0 means the repository is never assumed
               offline.
        :param pulumi.Input[builtins.bool] blacked_out: (A.K.A 'Ignore Repository' on the UI) When set, the repository or its local cache do not participate in artifact
               resolution.
        :param pulumi.Input[builtins.bool] block_mismatching_mime_types: If set, artifacts will fail to download if a mismatch is detected between requested and received mimetype, according to
               the list specified in the system properties file under blockedMismatchingMimeTypes. You can override by adding mimetypes
               to the override list 'mismatching_mime_types_override_list'.
        :param pulumi.Input[builtins.bool] bypass_head_requests: Before caching an artifact, Artifactory first sends a HEAD request to the remote resource. In some remote resources,
               HEAD requests are disallowed and therefore rejected, even though downloading the artifact is allowed. When checked,
               Artifactory will bypass the HEAD request and cache the artifact directly using a GET request.
        :param pulumi.Input[builtins.bool] cdn_redirect: When set, download requests to this repository will redirect the client to download the artifact directly from AWS
               CloudFront. Available in Enterprise+ and Edge licenses only. Default value is 'false'
        :param pulumi.Input[builtins.str] client_tls_certificate: Client TLS certificate name.
        :param pulumi.Input[builtins.str] description: Public description.
        :param pulumi.Input[builtins.bool] disable_proxy: When set to `true`, the proxy is disabled, and not returned in the API response body. If there is a default proxy set
               for the Artifactory instance, it will be ignored, too. Introduced since Artifactory 7.41.7.
        :param pulumi.Input[builtins.bool] disable_url_normalization: Whether to disable URL normalization. Default is `false`.
        :param pulumi.Input[builtins.bool] download_direct: When set, download requests to this repository will redirect the client to download the artifact directly from the cloud
               storage provider. Available in Enterprise+ and Edge licenses only. Default value is 'false'.
        :param pulumi.Input[builtins.bool] enable_cookie_management: Enables cookie management if the remote repository uses cookies to manage client state.
        :param pulumi.Input[builtins.str] excludes_pattern: List of artifact patterns to exclude when evaluating artifact requests, in the form of `x/y/**/z/*`.By default no
               artifacts are excluded.
        :param pulumi.Input[builtins.bool] hard_fail: When set, Artifactory will return an error to the client that causes the build to fail if there is a failure to
               communicate with this repository.
        :param pulumi.Input[builtins.str] includes_pattern: List of comma-separated artifact patterns to include when evaluating artifact requests in the form of `x/y/**/z/*`. When
               used, only artifacts matching one of the include patterns are served. By default, all artifacts are included (`**/*`).
        :param pulumi.Input[builtins.str] key: A mandatory identifier for the repository that must be unique. It cannot begin with a number or
               contain spaces or special characters.
        :param pulumi.Input[builtins.bool] list_remote_folder_items: Lists the items of remote folders in simple and list browsing. The remote content is cached according to the value of
               the 'Retrieval Cache Period'. Default value is 'false'. This field exists in the API but not in the UI.
        :param pulumi.Input[builtins.str] local_address: The local address to be used when creating connections. Useful for specifying the interface to use on systems with
               multiple network interfaces.
        :param pulumi.Input[builtins.int] metadata_retrieval_timeout_secs: Metadata Retrieval Cache Timeout (Sec) in the UI.This value refers to the number of seconds to wait for retrieval from
               the remote before serving locally cached artifact or fail the request.
        :param pulumi.Input[builtins.str] mismatching_mime_types_override_list: The set of mime types that should override the block_mismatching_mime_types setting. Eg:
               'application/json,application/xml'. Default value is empty.
        :param pulumi.Input[builtins.int] missed_cache_period_seconds: Missed Retrieval Cache Period (Sec) in the UI. The number of seconds to cache artifact retrieval misses (artifact not
               found). A value of 0 indicates no caching.
        :param pulumi.Input[builtins.str] notes: Internal description.
        :param pulumi.Input[builtins.bool] offline: If set, Artifactory does not try to fetch remote artifacts. Only locally-cached artifacts are retrieved.
        :param pulumi.Input[builtins.bool] priority_resolution: Setting repositories with priority will cause metadata to be merged only from repositories set with this field
        :param pulumi.Input[builtins.str] project_key: Project key for assigning this repository to. Must be 2 - 32 lowercase alphanumeric and hyphen characters. When
               assigning repository to a project, repository key must be prefixed with project key, separated by a dash.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] property_sets: List of property set name
        :param pulumi.Input[builtins.str] proxy: Proxy key from Artifactory Proxies settings. Can't be set if `disable_proxy = true`.
        :param pulumi.Input[builtins.str] query_params: Custom HTTP query parameters that will be automatically included in all remote resource requests. For example:
               `param1=val1&param2=val2&param3=val3`
        :param pulumi.Input[builtins.str] remote_repo_layout_ref: Repository layout key for the remote layout mapping. Repository can be created without this attribute (or set to an
               empty string). Once it's set, it can't be removed by passing an empty string or removing the attribute, that will be
               ignored by the Artifactory API. UI shows an error message, if the user tries to remove the value.
        :param pulumi.Input[builtins.str] repo_layout_ref: Sets the layout that the repository should use for storing and identifying modules. A recommended layout that
               corresponds to the package type defined is suggested, and index packages uploaded and calculate metadata accordingly.
        :param pulumi.Input[builtins.int] retrieval_cache_period_seconds: Metadata Retrieval Cache Period (Sec) in the UI. This value refers to the number of seconds to cache metadata files
               before checking for newer versions on remote server. A value of 0 indicates no caching.
        :param pulumi.Input[builtins.int] socket_timeout_millis: Network timeout (in ms) to use when establishing a connection and for unanswered requests. Timing out on a network
               operation is considered a retrieval failure.
        :param pulumi.Input[builtins.bool] store_artifacts_locally: When set, the repository should store cached artifacts locally. When not set, artifacts are not stored locally, and
               direct repository-to-client streaming is used. This can be useful for multi-server setups over a high-speed LAN, with
               one Artifactory caching certain data on central storage, and streaming it directly to satellite pass-though Artifactory
               servers.
        :param pulumi.Input[builtins.bool] synchronize_properties: When set, remote artifacts are fetched along with their properties.
        :param pulumi.Input[builtins.int] unused_artifacts_cleanup_period_hours: Unused Artifacts Cleanup Period (Hr) in the UI. The number of hours to wait before an artifact is deemed 'unused' and
               eligible for cleanup from the repository. A value of 0 means automatic cleanup of cached artifacts is disabled.
        :param pulumi.Input[builtins.str] url: The remote repo URL.
        :param pulumi.Input[builtins.bool] xray_index: Enable Indexing In Xray. Repository will be indexed with the default retention period. You will be able to change it via
               Xray settings.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: RemoteAnsibleRepositoryArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Creates a remote Ansible repository.

        Official documentation can be found [here](https://jfrog.com/help/r/jfrog-artifactory-documentation/ansible-repositories).

        ## Example Usage

        ```python
        import pulumi
        import pulumi_artifactory as artifactory

        my_remote_ansible = artifactory.RemoteAlpineRepository("my-remote-ansible",
            key="my-remote-ansible",
            url="https://galaxy.ansible.com")
        ```

        ## Import

        Remote repositories can be imported using their name, e.g.

        ```sh
        $ pulumi import artifactory:index/remoteAnsibleRepository:RemoteAnsibleRepository my-remote-ansible my-remote-ansible
        ```

        :param str resource_name: The name of the resource.
        :param RemoteAnsibleRepositoryArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(RemoteAnsibleRepositoryArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 allow_any_host_auth: Optional[pulumi.Input[builtins.bool]] = None,
                 archive_browsing_enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 assumed_offline_period_secs: Optional[pulumi.Input[builtins.int]] = None,
                 blacked_out: Optional[pulumi.Input[builtins.bool]] = None,
                 block_mismatching_mime_types: Optional[pulumi.Input[builtins.bool]] = None,
                 bypass_head_requests: Optional[pulumi.Input[builtins.bool]] = None,
                 cdn_redirect: Optional[pulumi.Input[builtins.bool]] = None,
                 client_tls_certificate: Optional[pulumi.Input[builtins.str]] = None,
                 content_synchronisation: Optional[pulumi.Input[Union['RemoteAnsibleRepositoryContentSynchronisationArgs', 'RemoteAnsibleRepositoryContentSynchronisationArgsDict']]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 disable_proxy: Optional[pulumi.Input[builtins.bool]] = None,
                 disable_url_normalization: Optional[pulumi.Input[builtins.bool]] = None,
                 download_direct: Optional[pulumi.Input[builtins.bool]] = None,
                 enable_cookie_management: Optional[pulumi.Input[builtins.bool]] = None,
                 excludes_pattern: Optional[pulumi.Input[builtins.str]] = None,
                 hard_fail: Optional[pulumi.Input[builtins.bool]] = None,
                 includes_pattern: Optional[pulumi.Input[builtins.str]] = None,
                 key: Optional[pulumi.Input[builtins.str]] = None,
                 list_remote_folder_items: Optional[pulumi.Input[builtins.bool]] = None,
                 local_address: Optional[pulumi.Input[builtins.str]] = None,
                 metadata_retrieval_timeout_secs: Optional[pulumi.Input[builtins.int]] = None,
                 mismatching_mime_types_override_list: Optional[pulumi.Input[builtins.str]] = None,
                 missed_cache_period_seconds: Optional[pulumi.Input[builtins.int]] = None,
                 notes: Optional[pulumi.Input[builtins.str]] = None,
                 offline: Optional[pulumi.Input[builtins.bool]] = None,
                 password: Optional[pulumi.Input[builtins.str]] = None,
                 priority_resolution: Optional[pulumi.Input[builtins.bool]] = None,
                 project_environments: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 project_key: Optional[pulumi.Input[builtins.str]] = None,
                 property_sets: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 proxy: Optional[pulumi.Input[builtins.str]] = None,
                 query_params: Optional[pulumi.Input[builtins.str]] = None,
                 remote_repo_layout_ref: Optional[pulumi.Input[builtins.str]] = None,
                 repo_layout_ref: Optional[pulumi.Input[builtins.str]] = None,
                 retrieval_cache_period_seconds: Optional[pulumi.Input[builtins.int]] = None,
                 share_configuration: Optional[pulumi.Input[builtins.bool]] = None,
                 socket_timeout_millis: Optional[pulumi.Input[builtins.int]] = None,
                 store_artifacts_locally: Optional[pulumi.Input[builtins.bool]] = None,
                 synchronize_properties: Optional[pulumi.Input[builtins.bool]] = None,
                 unused_artifacts_cleanup_period_hours: Optional[pulumi.Input[builtins.int]] = None,
                 url: Optional[pulumi.Input[builtins.str]] = None,
                 username: Optional[pulumi.Input[builtins.str]] = None,
                 xray_index: Optional[pulumi.Input[builtins.bool]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = RemoteAnsibleRepositoryArgs.__new__(RemoteAnsibleRepositoryArgs)

            __props__.__dict__["allow_any_host_auth"] = allow_any_host_auth
            __props__.__dict__["archive_browsing_enabled"] = archive_browsing_enabled
            __props__.__dict__["assumed_offline_period_secs"] = assumed_offline_period_secs
            __props__.__dict__["blacked_out"] = blacked_out
            __props__.__dict__["block_mismatching_mime_types"] = block_mismatching_mime_types
            __props__.__dict__["bypass_head_requests"] = bypass_head_requests
            __props__.__dict__["cdn_redirect"] = cdn_redirect
            __props__.__dict__["client_tls_certificate"] = client_tls_certificate
            __props__.__dict__["content_synchronisation"] = content_synchronisation
            __props__.__dict__["description"] = description
            __props__.__dict__["disable_proxy"] = disable_proxy
            __props__.__dict__["disable_url_normalization"] = disable_url_normalization
            __props__.__dict__["download_direct"] = download_direct
            __props__.__dict__["enable_cookie_management"] = enable_cookie_management
            __props__.__dict__["excludes_pattern"] = excludes_pattern
            __props__.__dict__["hard_fail"] = hard_fail
            __props__.__dict__["includes_pattern"] = includes_pattern
            if key is None and not opts.urn:
                raise TypeError("Missing required property 'key'")
            __props__.__dict__["key"] = key
            __props__.__dict__["list_remote_folder_items"] = list_remote_folder_items
            __props__.__dict__["local_address"] = local_address
            __props__.__dict__["metadata_retrieval_timeout_secs"] = metadata_retrieval_timeout_secs
            __props__.__dict__["mismatching_mime_types_override_list"] = mismatching_mime_types_override_list
            __props__.__dict__["missed_cache_period_seconds"] = missed_cache_period_seconds
            __props__.__dict__["notes"] = notes
            __props__.__dict__["offline"] = offline
            __props__.__dict__["password"] = None if password is None else pulumi.Output.secret(password)
            __props__.__dict__["priority_resolution"] = priority_resolution
            __props__.__dict__["project_environments"] = project_environments
            __props__.__dict__["project_key"] = project_key
            __props__.__dict__["property_sets"] = property_sets
            __props__.__dict__["proxy"] = proxy
            __props__.__dict__["query_params"] = query_params
            __props__.__dict__["remote_repo_layout_ref"] = remote_repo_layout_ref
            __props__.__dict__["repo_layout_ref"] = repo_layout_ref
            __props__.__dict__["retrieval_cache_period_seconds"] = retrieval_cache_period_seconds
            __props__.__dict__["share_configuration"] = share_configuration
            __props__.__dict__["socket_timeout_millis"] = socket_timeout_millis
            __props__.__dict__["store_artifacts_locally"] = store_artifacts_locally
            __props__.__dict__["synchronize_properties"] = synchronize_properties
            __props__.__dict__["unused_artifacts_cleanup_period_hours"] = unused_artifacts_cleanup_period_hours
            __props__.__dict__["url"] = url
            __props__.__dict__["username"] = username
            __props__.__dict__["xray_index"] = xray_index
        secret_opts = pulumi.ResourceOptions(additional_secret_outputs=["password"])
        opts = pulumi.ResourceOptions.merge(opts, secret_opts)
        super(RemoteAnsibleRepository, __self__).__init__(
            'artifactory:index/remoteAnsibleRepository:RemoteAnsibleRepository',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            allow_any_host_auth: Optional[pulumi.Input[builtins.bool]] = None,
            archive_browsing_enabled: Optional[pulumi.Input[builtins.bool]] = None,
            assumed_offline_period_secs: Optional[pulumi.Input[builtins.int]] = None,
            blacked_out: Optional[pulumi.Input[builtins.bool]] = None,
            block_mismatching_mime_types: Optional[pulumi.Input[builtins.bool]] = None,
            bypass_head_requests: Optional[pulumi.Input[builtins.bool]] = None,
            cdn_redirect: Optional[pulumi.Input[builtins.bool]] = None,
            client_tls_certificate: Optional[pulumi.Input[builtins.str]] = None,
            content_synchronisation: Optional[pulumi.Input[Union['RemoteAnsibleRepositoryContentSynchronisationArgs', 'RemoteAnsibleRepositoryContentSynchronisationArgsDict']]] = None,
            description: Optional[pulumi.Input[builtins.str]] = None,
            disable_proxy: Optional[pulumi.Input[builtins.bool]] = None,
            disable_url_normalization: Optional[pulumi.Input[builtins.bool]] = None,
            download_direct: Optional[pulumi.Input[builtins.bool]] = None,
            enable_cookie_management: Optional[pulumi.Input[builtins.bool]] = None,
            excludes_pattern: Optional[pulumi.Input[builtins.str]] = None,
            hard_fail: Optional[pulumi.Input[builtins.bool]] = None,
            includes_pattern: Optional[pulumi.Input[builtins.str]] = None,
            key: Optional[pulumi.Input[builtins.str]] = None,
            list_remote_folder_items: Optional[pulumi.Input[builtins.bool]] = None,
            local_address: Optional[pulumi.Input[builtins.str]] = None,
            metadata_retrieval_timeout_secs: Optional[pulumi.Input[builtins.int]] = None,
            mismatching_mime_types_override_list: Optional[pulumi.Input[builtins.str]] = None,
            missed_cache_period_seconds: Optional[pulumi.Input[builtins.int]] = None,
            notes: Optional[pulumi.Input[builtins.str]] = None,
            offline: Optional[pulumi.Input[builtins.bool]] = None,
            password: Optional[pulumi.Input[builtins.str]] = None,
            priority_resolution: Optional[pulumi.Input[builtins.bool]] = None,
            project_environments: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
            project_key: Optional[pulumi.Input[builtins.str]] = None,
            property_sets: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
            proxy: Optional[pulumi.Input[builtins.str]] = None,
            query_params: Optional[pulumi.Input[builtins.str]] = None,
            remote_repo_layout_ref: Optional[pulumi.Input[builtins.str]] = None,
            repo_layout_ref: Optional[pulumi.Input[builtins.str]] = None,
            retrieval_cache_period_seconds: Optional[pulumi.Input[builtins.int]] = None,
            share_configuration: Optional[pulumi.Input[builtins.bool]] = None,
            socket_timeout_millis: Optional[pulumi.Input[builtins.int]] = None,
            store_artifacts_locally: Optional[pulumi.Input[builtins.bool]] = None,
            synchronize_properties: Optional[pulumi.Input[builtins.bool]] = None,
            unused_artifacts_cleanup_period_hours: Optional[pulumi.Input[builtins.int]] = None,
            url: Optional[pulumi.Input[builtins.str]] = None,
            username: Optional[pulumi.Input[builtins.str]] = None,
            xray_index: Optional[pulumi.Input[builtins.bool]] = None) -> 'RemoteAnsibleRepository':
        """
        Get an existing RemoteAnsibleRepository resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.bool] allow_any_host_auth: 'Lenient Host Authentication' in the UI. Allow credentials of this repository to be used on requests redirected to any
               other host.
        :param pulumi.Input[builtins.bool] archive_browsing_enabled: When set, you may view content such as HTML or Javadoc files directly from Artifactory. This may not be safe and
               therefore requires strict content moderation to prevent malicious users from uploading content that may compromise
               security (e.g., cross-site scripting attacks).
        :param pulumi.Input[builtins.int] assumed_offline_period_secs: The number of seconds the repository stays in assumed offline state after a connection error. At the end of this time,
               an online check is attempted in order to reset the offline status. A value of 0 means the repository is never assumed
               offline.
        :param pulumi.Input[builtins.bool] blacked_out: (A.K.A 'Ignore Repository' on the UI) When set, the repository or its local cache do not participate in artifact
               resolution.
        :param pulumi.Input[builtins.bool] block_mismatching_mime_types: If set, artifacts will fail to download if a mismatch is detected between requested and received mimetype, according to
               the list specified in the system properties file under blockedMismatchingMimeTypes. You can override by adding mimetypes
               to the override list 'mismatching_mime_types_override_list'.
        :param pulumi.Input[builtins.bool] bypass_head_requests: Before caching an artifact, Artifactory first sends a HEAD request to the remote resource. In some remote resources,
               HEAD requests are disallowed and therefore rejected, even though downloading the artifact is allowed. When checked,
               Artifactory will bypass the HEAD request and cache the artifact directly using a GET request.
        :param pulumi.Input[builtins.bool] cdn_redirect: When set, download requests to this repository will redirect the client to download the artifact directly from AWS
               CloudFront. Available in Enterprise+ and Edge licenses only. Default value is 'false'
        :param pulumi.Input[builtins.str] client_tls_certificate: Client TLS certificate name.
        :param pulumi.Input[builtins.str] description: Public description.
        :param pulumi.Input[builtins.bool] disable_proxy: When set to `true`, the proxy is disabled, and not returned in the API response body. If there is a default proxy set
               for the Artifactory instance, it will be ignored, too. Introduced since Artifactory 7.41.7.
        :param pulumi.Input[builtins.bool] disable_url_normalization: Whether to disable URL normalization. Default is `false`.
        :param pulumi.Input[builtins.bool] download_direct: When set, download requests to this repository will redirect the client to download the artifact directly from the cloud
               storage provider. Available in Enterprise+ and Edge licenses only. Default value is 'false'.
        :param pulumi.Input[builtins.bool] enable_cookie_management: Enables cookie management if the remote repository uses cookies to manage client state.
        :param pulumi.Input[builtins.str] excludes_pattern: List of artifact patterns to exclude when evaluating artifact requests, in the form of `x/y/**/z/*`.By default no
               artifacts are excluded.
        :param pulumi.Input[builtins.bool] hard_fail: When set, Artifactory will return an error to the client that causes the build to fail if there is a failure to
               communicate with this repository.
        :param pulumi.Input[builtins.str] includes_pattern: List of comma-separated artifact patterns to include when evaluating artifact requests in the form of `x/y/**/z/*`. When
               used, only artifacts matching one of the include patterns are served. By default, all artifacts are included (`**/*`).
        :param pulumi.Input[builtins.str] key: A mandatory identifier for the repository that must be unique. It cannot begin with a number or
               contain spaces or special characters.
        :param pulumi.Input[builtins.bool] list_remote_folder_items: Lists the items of remote folders in simple and list browsing. The remote content is cached according to the value of
               the 'Retrieval Cache Period'. Default value is 'false'. This field exists in the API but not in the UI.
        :param pulumi.Input[builtins.str] local_address: The local address to be used when creating connections. Useful for specifying the interface to use on systems with
               multiple network interfaces.
        :param pulumi.Input[builtins.int] metadata_retrieval_timeout_secs: Metadata Retrieval Cache Timeout (Sec) in the UI.This value refers to the number of seconds to wait for retrieval from
               the remote before serving locally cached artifact or fail the request.
        :param pulumi.Input[builtins.str] mismatching_mime_types_override_list: The set of mime types that should override the block_mismatching_mime_types setting. Eg:
               'application/json,application/xml'. Default value is empty.
        :param pulumi.Input[builtins.int] missed_cache_period_seconds: Missed Retrieval Cache Period (Sec) in the UI. The number of seconds to cache artifact retrieval misses (artifact not
               found). A value of 0 indicates no caching.
        :param pulumi.Input[builtins.str] notes: Internal description.
        :param pulumi.Input[builtins.bool] offline: If set, Artifactory does not try to fetch remote artifacts. Only locally-cached artifacts are retrieved.
        :param pulumi.Input[builtins.bool] priority_resolution: Setting repositories with priority will cause metadata to be merged only from repositories set with this field
        :param pulumi.Input[builtins.str] project_key: Project key for assigning this repository to. Must be 2 - 32 lowercase alphanumeric and hyphen characters. When
               assigning repository to a project, repository key must be prefixed with project key, separated by a dash.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] property_sets: List of property set name
        :param pulumi.Input[builtins.str] proxy: Proxy key from Artifactory Proxies settings. Can't be set if `disable_proxy = true`.
        :param pulumi.Input[builtins.str] query_params: Custom HTTP query parameters that will be automatically included in all remote resource requests. For example:
               `param1=val1&param2=val2&param3=val3`
        :param pulumi.Input[builtins.str] remote_repo_layout_ref: Repository layout key for the remote layout mapping. Repository can be created without this attribute (or set to an
               empty string). Once it's set, it can't be removed by passing an empty string or removing the attribute, that will be
               ignored by the Artifactory API. UI shows an error message, if the user tries to remove the value.
        :param pulumi.Input[builtins.str] repo_layout_ref: Sets the layout that the repository should use for storing and identifying modules. A recommended layout that
               corresponds to the package type defined is suggested, and index packages uploaded and calculate metadata accordingly.
        :param pulumi.Input[builtins.int] retrieval_cache_period_seconds: Metadata Retrieval Cache Period (Sec) in the UI. This value refers to the number of seconds to cache metadata files
               before checking for newer versions on remote server. A value of 0 indicates no caching.
        :param pulumi.Input[builtins.int] socket_timeout_millis: Network timeout (in ms) to use when establishing a connection and for unanswered requests. Timing out on a network
               operation is considered a retrieval failure.
        :param pulumi.Input[builtins.bool] store_artifacts_locally: When set, the repository should store cached artifacts locally. When not set, artifacts are not stored locally, and
               direct repository-to-client streaming is used. This can be useful for multi-server setups over a high-speed LAN, with
               one Artifactory caching certain data on central storage, and streaming it directly to satellite pass-though Artifactory
               servers.
        :param pulumi.Input[builtins.bool] synchronize_properties: When set, remote artifacts are fetched along with their properties.
        :param pulumi.Input[builtins.int] unused_artifacts_cleanup_period_hours: Unused Artifacts Cleanup Period (Hr) in the UI. The number of hours to wait before an artifact is deemed 'unused' and
               eligible for cleanup from the repository. A value of 0 means automatic cleanup of cached artifacts is disabled.
        :param pulumi.Input[builtins.str] url: The remote repo URL.
        :param pulumi.Input[builtins.bool] xray_index: Enable Indexing In Xray. Repository will be indexed with the default retention period. You will be able to change it via
               Xray settings.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _RemoteAnsibleRepositoryState.__new__(_RemoteAnsibleRepositoryState)

        __props__.__dict__["allow_any_host_auth"] = allow_any_host_auth
        __props__.__dict__["archive_browsing_enabled"] = archive_browsing_enabled
        __props__.__dict__["assumed_offline_period_secs"] = assumed_offline_period_secs
        __props__.__dict__["blacked_out"] = blacked_out
        __props__.__dict__["block_mismatching_mime_types"] = block_mismatching_mime_types
        __props__.__dict__["bypass_head_requests"] = bypass_head_requests
        __props__.__dict__["cdn_redirect"] = cdn_redirect
        __props__.__dict__["client_tls_certificate"] = client_tls_certificate
        __props__.__dict__["content_synchronisation"] = content_synchronisation
        __props__.__dict__["description"] = description
        __props__.__dict__["disable_proxy"] = disable_proxy
        __props__.__dict__["disable_url_normalization"] = disable_url_normalization
        __props__.__dict__["download_direct"] = download_direct
        __props__.__dict__["enable_cookie_management"] = enable_cookie_management
        __props__.__dict__["excludes_pattern"] = excludes_pattern
        __props__.__dict__["hard_fail"] = hard_fail
        __props__.__dict__["includes_pattern"] = includes_pattern
        __props__.__dict__["key"] = key
        __props__.__dict__["list_remote_folder_items"] = list_remote_folder_items
        __props__.__dict__["local_address"] = local_address
        __props__.__dict__["metadata_retrieval_timeout_secs"] = metadata_retrieval_timeout_secs
        __props__.__dict__["mismatching_mime_types_override_list"] = mismatching_mime_types_override_list
        __props__.__dict__["missed_cache_period_seconds"] = missed_cache_period_seconds
        __props__.__dict__["notes"] = notes
        __props__.__dict__["offline"] = offline
        __props__.__dict__["password"] = password
        __props__.__dict__["priority_resolution"] = priority_resolution
        __props__.__dict__["project_environments"] = project_environments
        __props__.__dict__["project_key"] = project_key
        __props__.__dict__["property_sets"] = property_sets
        __props__.__dict__["proxy"] = proxy
        __props__.__dict__["query_params"] = query_params
        __props__.__dict__["remote_repo_layout_ref"] = remote_repo_layout_ref
        __props__.__dict__["repo_layout_ref"] = repo_layout_ref
        __props__.__dict__["retrieval_cache_period_seconds"] = retrieval_cache_period_seconds
        __props__.__dict__["share_configuration"] = share_configuration
        __props__.__dict__["socket_timeout_millis"] = socket_timeout_millis
        __props__.__dict__["store_artifacts_locally"] = store_artifacts_locally
        __props__.__dict__["synchronize_properties"] = synchronize_properties
        __props__.__dict__["unused_artifacts_cleanup_period_hours"] = unused_artifacts_cleanup_period_hours
        __props__.__dict__["url"] = url
        __props__.__dict__["username"] = username
        __props__.__dict__["xray_index"] = xray_index
        return RemoteAnsibleRepository(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="allowAnyHostAuth")
    def allow_any_host_auth(self) -> pulumi.Output[builtins.bool]:
        """
        'Lenient Host Authentication' in the UI. Allow credentials of this repository to be used on requests redirected to any
        other host.
        """
        return pulumi.get(self, "allow_any_host_auth")

    @property
    @pulumi.getter(name="archiveBrowsingEnabled")
    def archive_browsing_enabled(self) -> pulumi.Output[builtins.bool]:
        """
        When set, you may view content such as HTML or Javadoc files directly from Artifactory. This may not be safe and
        therefore requires strict content moderation to prevent malicious users from uploading content that may compromise
        security (e.g., cross-site scripting attacks).
        """
        return pulumi.get(self, "archive_browsing_enabled")

    @property
    @pulumi.getter(name="assumedOfflinePeriodSecs")
    def assumed_offline_period_secs(self) -> pulumi.Output[builtins.int]:
        """
        The number of seconds the repository stays in assumed offline state after a connection error. At the end of this time,
        an online check is attempted in order to reset the offline status. A value of 0 means the repository is never assumed
        offline.
        """
        return pulumi.get(self, "assumed_offline_period_secs")

    @property
    @pulumi.getter(name="blackedOut")
    def blacked_out(self) -> pulumi.Output[builtins.bool]:
        """
        (A.K.A 'Ignore Repository' on the UI) When set, the repository or its local cache do not participate in artifact
        resolution.
        """
        return pulumi.get(self, "blacked_out")

    @property
    @pulumi.getter(name="blockMismatchingMimeTypes")
    def block_mismatching_mime_types(self) -> pulumi.Output[builtins.bool]:
        """
        If set, artifacts will fail to download if a mismatch is detected between requested and received mimetype, according to
        the list specified in the system properties file under blockedMismatchingMimeTypes. You can override by adding mimetypes
        to the override list 'mismatching_mime_types_override_list'.
        """
        return pulumi.get(self, "block_mismatching_mime_types")

    @property
    @pulumi.getter(name="bypassHeadRequests")
    def bypass_head_requests(self) -> pulumi.Output[builtins.bool]:
        """
        Before caching an artifact, Artifactory first sends a HEAD request to the remote resource. In some remote resources,
        HEAD requests are disallowed and therefore rejected, even though downloading the artifact is allowed. When checked,
        Artifactory will bypass the HEAD request and cache the artifact directly using a GET request.
        """
        return pulumi.get(self, "bypass_head_requests")

    @property
    @pulumi.getter(name="cdnRedirect")
    def cdn_redirect(self) -> pulumi.Output[builtins.bool]:
        """
        When set, download requests to this repository will redirect the client to download the artifact directly from AWS
        CloudFront. Available in Enterprise+ and Edge licenses only. Default value is 'false'
        """
        return pulumi.get(self, "cdn_redirect")

    @property
    @pulumi.getter(name="clientTlsCertificate")
    def client_tls_certificate(self) -> pulumi.Output[builtins.str]:
        """
        Client TLS certificate name.
        """
        return pulumi.get(self, "client_tls_certificate")

    @property
    @pulumi.getter(name="contentSynchronisation")
    def content_synchronisation(self) -> pulumi.Output[Optional['outputs.RemoteAnsibleRepositoryContentSynchronisation']]:
        return pulumi.get(self, "content_synchronisation")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[builtins.str]:
        """
        Public description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="disableProxy")
    def disable_proxy(self) -> pulumi.Output[builtins.bool]:
        """
        When set to `true`, the proxy is disabled, and not returned in the API response body. If there is a default proxy set
        for the Artifactory instance, it will be ignored, too. Introduced since Artifactory 7.41.7.
        """
        return pulumi.get(self, "disable_proxy")

    @property
    @pulumi.getter(name="disableUrlNormalization")
    def disable_url_normalization(self) -> pulumi.Output[builtins.bool]:
        """
        Whether to disable URL normalization. Default is `false`.
        """
        return pulumi.get(self, "disable_url_normalization")

    @property
    @pulumi.getter(name="downloadDirect")
    def download_direct(self) -> pulumi.Output[builtins.bool]:
        """
        When set, download requests to this repository will redirect the client to download the artifact directly from the cloud
        storage provider. Available in Enterprise+ and Edge licenses only. Default value is 'false'.
        """
        return pulumi.get(self, "download_direct")

    @property
    @pulumi.getter(name="enableCookieManagement")
    def enable_cookie_management(self) -> pulumi.Output[builtins.bool]:
        """
        Enables cookie management if the remote repository uses cookies to manage client state.
        """
        return pulumi.get(self, "enable_cookie_management")

    @property
    @pulumi.getter(name="excludesPattern")
    def excludes_pattern(self) -> pulumi.Output[builtins.str]:
        """
        List of artifact patterns to exclude when evaluating artifact requests, in the form of `x/y/**/z/*`.By default no
        artifacts are excluded.
        """
        return pulumi.get(self, "excludes_pattern")

    @property
    @pulumi.getter(name="hardFail")
    def hard_fail(self) -> pulumi.Output[builtins.bool]:
        """
        When set, Artifactory will return an error to the client that causes the build to fail if there is a failure to
        communicate with this repository.
        """
        return pulumi.get(self, "hard_fail")

    @property
    @pulumi.getter(name="includesPattern")
    def includes_pattern(self) -> pulumi.Output[builtins.str]:
        """
        List of comma-separated artifact patterns to include when evaluating artifact requests in the form of `x/y/**/z/*`. When
        used, only artifacts matching one of the include patterns are served. By default, all artifacts are included (`**/*`).
        """
        return pulumi.get(self, "includes_pattern")

    @property
    @pulumi.getter
    def key(self) -> pulumi.Output[builtins.str]:
        """
        A mandatory identifier for the repository that must be unique. It cannot begin with a number or
        contain spaces or special characters.
        """
        return pulumi.get(self, "key")

    @property
    @pulumi.getter(name="listRemoteFolderItems")
    def list_remote_folder_items(self) -> pulumi.Output[builtins.bool]:
        """
        Lists the items of remote folders in simple and list browsing. The remote content is cached according to the value of
        the 'Retrieval Cache Period'. Default value is 'false'. This field exists in the API but not in the UI.
        """
        return pulumi.get(self, "list_remote_folder_items")

    @property
    @pulumi.getter(name="localAddress")
    def local_address(self) -> pulumi.Output[builtins.str]:
        """
        The local address to be used when creating connections. Useful for specifying the interface to use on systems with
        multiple network interfaces.
        """
        return pulumi.get(self, "local_address")

    @property
    @pulumi.getter(name="metadataRetrievalTimeoutSecs")
    def metadata_retrieval_timeout_secs(self) -> pulumi.Output[builtins.int]:
        """
        Metadata Retrieval Cache Timeout (Sec) in the UI.This value refers to the number of seconds to wait for retrieval from
        the remote before serving locally cached artifact or fail the request.
        """
        return pulumi.get(self, "metadata_retrieval_timeout_secs")

    @property
    @pulumi.getter(name="mismatchingMimeTypesOverrideList")
    def mismatching_mime_types_override_list(self) -> pulumi.Output[builtins.str]:
        """
        The set of mime types that should override the block_mismatching_mime_types setting. Eg:
        'application/json,application/xml'. Default value is empty.
        """
        return pulumi.get(self, "mismatching_mime_types_override_list")

    @property
    @pulumi.getter(name="missedCachePeriodSeconds")
    def missed_cache_period_seconds(self) -> pulumi.Output[builtins.int]:
        """
        Missed Retrieval Cache Period (Sec) in the UI. The number of seconds to cache artifact retrieval misses (artifact not
        found). A value of 0 indicates no caching.
        """
        return pulumi.get(self, "missed_cache_period_seconds")

    @property
    @pulumi.getter
    def notes(self) -> pulumi.Output[builtins.str]:
        """
        Internal description.
        """
        return pulumi.get(self, "notes")

    @property
    @pulumi.getter
    def offline(self) -> pulumi.Output[builtins.bool]:
        """
        If set, Artifactory does not try to fetch remote artifacts. Only locally-cached artifacts are retrieved.
        """
        return pulumi.get(self, "offline")

    @property
    @pulumi.getter
    def password(self) -> pulumi.Output[Optional[builtins.str]]:
        return pulumi.get(self, "password")

    @property
    @pulumi.getter(name="priorityResolution")
    def priority_resolution(self) -> pulumi.Output[builtins.bool]:
        """
        Setting repositories with priority will cause metadata to be merged only from repositories set with this field
        """
        return pulumi.get(self, "priority_resolution")

    @property
    @pulumi.getter(name="projectEnvironments")
    def project_environments(self) -> pulumi.Output[Sequence[builtins.str]]:
        return pulumi.get(self, "project_environments")

    @property
    @pulumi.getter(name="projectKey")
    def project_key(self) -> pulumi.Output[builtins.str]:
        """
        Project key for assigning this repository to. Must be 2 - 32 lowercase alphanumeric and hyphen characters. When
        assigning repository to a project, repository key must be prefixed with project key, separated by a dash.
        """
        return pulumi.get(self, "project_key")

    @property
    @pulumi.getter(name="propertySets")
    def property_sets(self) -> pulumi.Output[Optional[Sequence[builtins.str]]]:
        """
        List of property set name
        """
        return pulumi.get(self, "property_sets")

    @property
    @pulumi.getter
    def proxy(self) -> pulumi.Output[builtins.str]:
        """
        Proxy key from Artifactory Proxies settings. Can't be set if `disable_proxy = true`.
        """
        return pulumi.get(self, "proxy")

    @property
    @pulumi.getter(name="queryParams")
    def query_params(self) -> pulumi.Output[builtins.str]:
        """
        Custom HTTP query parameters that will be automatically included in all remote resource requests. For example:
        `param1=val1&param2=val2&param3=val3`
        """
        return pulumi.get(self, "query_params")

    @property
    @pulumi.getter(name="remoteRepoLayoutRef")
    def remote_repo_layout_ref(self) -> pulumi.Output[builtins.str]:
        """
        Repository layout key for the remote layout mapping. Repository can be created without this attribute (or set to an
        empty string). Once it's set, it can't be removed by passing an empty string or removing the attribute, that will be
        ignored by the Artifactory API. UI shows an error message, if the user tries to remove the value.
        """
        return pulumi.get(self, "remote_repo_layout_ref")

    @property
    @pulumi.getter(name="repoLayoutRef")
    def repo_layout_ref(self) -> pulumi.Output[builtins.str]:
        """
        Sets the layout that the repository should use for storing and identifying modules. A recommended layout that
        corresponds to the package type defined is suggested, and index packages uploaded and calculate metadata accordingly.
        """
        return pulumi.get(self, "repo_layout_ref")

    @property
    @pulumi.getter(name="retrievalCachePeriodSeconds")
    def retrieval_cache_period_seconds(self) -> pulumi.Output[builtins.int]:
        """
        Metadata Retrieval Cache Period (Sec) in the UI. This value refers to the number of seconds to cache metadata files
        before checking for newer versions on remote server. A value of 0 indicates no caching.
        """
        return pulumi.get(self, "retrieval_cache_period_seconds")

    @property
    @pulumi.getter(name="shareConfiguration")
    @_utilities.deprecated("""No longer supported""")
    def share_configuration(self) -> pulumi.Output[builtins.bool]:
        return pulumi.get(self, "share_configuration")

    @property
    @pulumi.getter(name="socketTimeoutMillis")
    def socket_timeout_millis(self) -> pulumi.Output[builtins.int]:
        """
        Network timeout (in ms) to use when establishing a connection and for unanswered requests. Timing out on a network
        operation is considered a retrieval failure.
        """
        return pulumi.get(self, "socket_timeout_millis")

    @property
    @pulumi.getter(name="storeArtifactsLocally")
    def store_artifacts_locally(self) -> pulumi.Output[builtins.bool]:
        """
        When set, the repository should store cached artifacts locally. When not set, artifacts are not stored locally, and
        direct repository-to-client streaming is used. This can be useful for multi-server setups over a high-speed LAN, with
        one Artifactory caching certain data on central storage, and streaming it directly to satellite pass-though Artifactory
        servers.
        """
        return pulumi.get(self, "store_artifacts_locally")

    @property
    @pulumi.getter(name="synchronizeProperties")
    def synchronize_properties(self) -> pulumi.Output[builtins.bool]:
        """
        When set, remote artifacts are fetched along with their properties.
        """
        return pulumi.get(self, "synchronize_properties")

    @property
    @pulumi.getter(name="unusedArtifactsCleanupPeriodHours")
    def unused_artifacts_cleanup_period_hours(self) -> pulumi.Output[builtins.int]:
        """
        Unused Artifacts Cleanup Period (Hr) in the UI. The number of hours to wait before an artifact is deemed 'unused' and
        eligible for cleanup from the repository. A value of 0 means automatic cleanup of cached artifacts is disabled.
        """
        return pulumi.get(self, "unused_artifacts_cleanup_period_hours")

    @property
    @pulumi.getter
    def url(self) -> pulumi.Output[builtins.str]:
        """
        The remote repo URL.
        """
        return pulumi.get(self, "url")

    @property
    @pulumi.getter
    def username(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "username")

    @property
    @pulumi.getter(name="xrayIndex")
    def xray_index(self) -> pulumi.Output[builtins.bool]:
        """
        Enable Indexing In Xray. Repository will be indexed with the default retention period. You will be able to change it via
        Xray settings.
        """
        return pulumi.get(self, "xray_index")

